<?php
/**
  * RMA Return System for osCommerce Online Merchant
  *
  * Author: frankl
  *
  * Portions @copyright (c) 2017 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */
  
 function tep_create_rma_value($length, $type = 'digits') {
    if ( ($type != 'mixed') && ($type != 'chars') && ($type != 'digits')) return false;

    $rand_value = '';
    while (strlen($rand_value)<$length) {
      if ($type == 'digits') {
        $char = tep_rand(0,9);
      } else {
        $char = chr(tep_rand(0,255));
      }
      if ($type == 'mixed') {
        if (eregi('^[a-z0-9]$', $char)) $rand_value .= $char;
      } elseif ($type == 'chars') {
        if (eregi('^[a-z]$', $char)) $rand_value .= $char;
      } else if ($type == 'digits') {
        if (ereg('^[0-9]$', $char)) $rand_value .= $char;
      }
    }

    return $rand_value;
  }

  function tep_get_return_reason() {
    global $languages_id;

    $orders_status_array = array();
    $orders_status_query = tep_db_query("select return_reason_id, return_reason_name from return_reasons where language_id = '" . $languages_id . "' order by return_reason_id");
    while ($orders_status = tep_db_fetch_array($orders_status_query)) {
      $orders_status_array[] = array('id' => $orders_status['return_reason_id'],
                                     'text' => $orders_status['return_reason_name']
                                    );
    }

    return $orders_status_array;
  }

    function tep_get_return_reason_name($return_reason_id, $language_id = '') {
    global $languages_id;

    if ($return_reason_id < 1) return TEXT_DEFAULT;

    if (!is_numeric($language_id)) $language_id = $languages_id;

    $status_query = tep_db_query("select return_reason_name from return_reasons where return_reason_id = '" . $return_reason_id . "' and language_id = '" . $language_id . "'");
    $status = tep_db_fetch_array($status_query);

    return $status['return_reason_name'];
  }



    function tep_calculate_deduct($price, $tax) {
    global $currencies;

    return (($price / 100) * $tax);
  }



     function tep_get_returns_status() {
    global $languages_id;

    $orders_status_array = array();
    $orders_status_query = tep_db_query("select returns_status_id, returns_status_name from returns_status where language_id = '" . $languages_id . "' order by returns_status_id");
    while ($orders_status = tep_db_fetch_array($orders_status_query)) {
      $orders_status_array[] = array('id' => $orders_status['returns_status_id'],
                                     'text' => $orders_status['returns_status_name']
                                    );
    }

    return $orders_status_array;
  }

    function tep_get_returns_status_name($returns_status_id, $language_id = '') {
    global $languages_id;

    if ($returns_status_id < 1) return TEXT_DEFAULT;

    if (!is_numeric($language_id)) $language_id = $languages_id;

    $status_query = tep_db_query("select returns_status_name from returns_status where returns_status_id = '" . $returns_status_id . "' and language_id = '" . $language_id . "'");
    $status = tep_db_fetch_array($status_query);

    return $status['returns_status_name'];
  }

       function tep_get_refund_method() {
    global $languages_id;

    $orders_status_array = array();
    $orders_status_query = tep_db_query("select refund_method_id, refund_method_name from refund_method where language_id = '" . $languages_id . "' order by refund_method_id");
    while ($orders_status = tep_db_fetch_array($orders_status_query)) {
      $orders_status_array[] = array('id' => $orders_status['refund_method_id'],
                                     'text' => $orders_status['refund_method_name']
                                    );
    }

    return $orders_status_array;
  }

    function tep_get_refund_method_name($refund_method_id, $language_id = '') {
    global $languages_id;

    if ($refund_method_id < 1) return TEXT_DEFAULT;

    if (!is_numeric($language_id)) $language_id = $languages_id;

    $status_query = tep_db_query("select refund_method_name from refund_method where refund_method_id = '" . $refund_method_id . "' and language_id = '" . $language_id . "'");
    $status = tep_db_fetch_array($status_query);

    return $status['refund_method_name'];
  }

   function tep_remove_return($order_id, $restock = false) {
    if ($restock == 'on') {
      $order_query = tep_db_query("select products_id, products_quantity from returns_products_data where returns_id = '" . tep_db_input($order_id) . "'");
      while ($order = tep_db_fetch_array($order_query)) {
      tep_db_query("update products set products_quantity = products_quantity + " . $order['products_quantity'] . " where products_id = '" . $order['products_id'] . "'");
	  tep_db_query("update products set products_status = 1 where products_quantity > 0 and products_id = '" . $order['products_id'] . "'");
      }
    }

    tep_db_query("delete from returned_products where returns_id = '" . tep_db_input($order_id) . "'");
    tep_db_query("delete from returns_products_data where returns_id = '" . tep_db_input($order_id) . "'");
    tep_db_query("delete from refund_payments where returns_id = '" . tep_db_input($order_id) . "'");
  }
