<?php
/**
  * RMA Return System for osCommerce Online Merchant
  *
  * Author: frankl
  *
  * Portions @copyright (c) 2017 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */
  
define('HEADING_TITLE', 'Product Exchange / Return');
define('HEADING_TITLE_SEARCH', 'Search RMAs:');
define('HEADING_TITLE_STATUS', 'Status:');
define('TEXT_DISPLAY_NUMBER_OF_RETURNS', 'Displaying <strong>%d</strong> to <strong>%d</strong> (of <strong>%d</strong> returns)');

define('SUCCESS_RETURN_UPDATED', 'Return Updated Successfully');
define('WARNING_RETURN_NOT_UPDATED', 'Return Not Updated');

define('TAB_TITLE_SUMMARY', 'Summary');
define('TAB_TITLE_PRODUCTS', 'Product');
define('TAB_TITLE_STATUS_HISTORY', 'Return History');


define('TEXT_ORDER_NO', 'Order Number:');
define('TEXT_RETURN_NO', 'Return Number:');
define('TEXT_RMA_VALUE', 'Customer RMA:');
define('TEXT_DATE_RETURN_CREATED', 'Date Created:');
define('TEXT_DATE_RETURN_LAST_MODIFIED', 'Last Modified:');
define('TEXT_INFO_DATE_COMPLETED', 'Completed:');
define('TEXT_ALL_RETURNS', 'All Returns');
define('TEXT_DATE_TIME', 'Request Date: ');
define('TEXT_TOTAL_DEDUCTIONS', 'Deductions');
define('TEXT_TOTAL_REFUNDED', 'Amount Refunded (finalised)');
define('TEXT_TOTAL_TO_BE_REFUNDED', 'Amount to be refunded');
define('TEXT_BACK_TO_STOCK', ' Add back to stock');
define('TEXT_PRODUCT_ALREADY_RETURNED', 'Item already added back to stock');


define('TABLE_HEADING_COMMENTS', 'Admin Comments');
define('TABLE_HEADING_CUSTOMERS', 'Customers');
define('TABLE_HEADING_RMA_NUMBER', 'RMA Number');
define('TABLE_HEADING_ORDER_TOTAL', 'Return Total');
define('TABLE_HEADING_DATE_PURCHASED', 'Request Date');
define('TABLE_HEADING_REASON', 'Reason');
define('TABLE_HEADING_STATUS', 'Status');
define('TABLE_HEADING_ACTION', 'Action');
define('TABLE_HEADING_PRODUCTS_MODEL', 'Model');
define('TABLE_HEADING_PRODUCTS', 'Products');
define('TABLE_HEADING_TAX', 'Tax');
define('TABLE_HEADING_STATUS', 'Status');
define('TABLE_HEADING_CUSTOMER_NOTIFIED', 'Customer Notified');
define('TABLE_HEADING_DATE_ADDED', 'Date Added');
define('TABLE_HEADING_TOTAL', 'Total');
define('TABLE_HEADING_STATUS', 'Status');
define('TABLE_HEADING_PRICE_EXCLUDING_TAX', 'Price (ex)');
define('TABLE_HEADING_PRICE_INCLUDING_TAX', 'Price (inc)');
define('TABLE_HEADING_TOTAL_EXCLUDING_TAX', 'Total (ex)');
define('TABLE_HEADING_TOTAL_INCLUDING_TAX', 'Total (inc)');


define('ENTRY_CUSTOMER', 'Customer: ');
define('ENTRY_SHIPPING_ADDRESS', 'Shipping Address: ');
define('ENTRY_BILLING_ADDRESS', 'Billing Address: ');
define('ENTRY_RETURNS_STATUS', 'Status: ');
define('ENTRY_RETURNS_CUSTOMER_PREF_REFUND', 'Customer\'s preferred resolution: ');
define('ENTRY_REFUND', 'Actual resolution: ');
define('ENTRY_ADD_COMMENT', 'Return comments: ');
define('ENTRY_RETURNS_REASON', 'Reason: ');
define('ENTRY_RETURNS_PAYMENT_REFERENCE', 'Refund Ref #: ');
define('ENTRY_NOTIFY_CUSTOMER', 'Notify Customer: ');
define('ENTRY_NOTIFY_COMMENTS', 'Append Comments: ');
define('ENTRY_PAYMENT_AMOUNT', 'Refund Amount: ');
define('ENTRY_RETURN_DETAILS', 'Return Details: ');
define('ENTRY_REFUND_DETAILS', 'Resolution: ');
define('ENTRY_ACTUAL_REFUND', 'Actual Refund: ');


define('TEXT_BUTTONS_ADD', 'Click to add comments ->');
define('TEXT_ORDER_COMPLETED', 'Return was marked as finalised on %s');
define('TEXT_BUTTON_RETURN_APPROVED', 'Approved');
define('TEXT_BUTTON_RETURN_REJECTED', 'Rejected');
define('TEXT_BUTTON_RETURN_CREDITED', 'Coupon to be sent');
define('TEXT_BUTTON_RETURN_REFUNDED', 'Will be refunded');
define('TEXT_BUTTON_RETURN_RESTOCK_APPLIED', 'Restocking fee applied');

define('SUCCESS_PRODUCT_TO_STOCK','Product added back to stock');
define('SUCCESS_RETURN_CLOSED','Return has now been finalised and closed.');

define('TEXT_INFO_HEADING_DELETE_RETURN', 'Delete Return');
define('TEXT_INFO_DELETE_INTRO', 'Are you sure you want to delete this return?');
define('TEXT_INFO_RMA_VALUE', 'RMA: ');

define('TEXT_RETURNS_SERIAL_NUMBER', 'Serial Number');

define('EMAIL_SEPARATOR', '===================================');
define('EMAIL_TEXT_SUBJECT', STORE_NAME . ' ' .'Return Update');
define('EMAIL_TEXT_COUPON_SUBJECT', STORE_NAME . ' '. 'Credit for returned product');
define('EMAIL_TEXT_ORDER_NUMBER', 'Return Number:');
define('EMAIL_TEXT_DATE_ORDERED', 'Return Request Date:');
define('EMAIL_TEXT_STATUS_UPDATE', '<b>Your return has been updated to the following status:</b>' . "\n" . 'New status: %s');
define('EMAIL_TEXT_REPLY', 'Please reply to this email if you have any questions.');
define('EMAIL_TEXT_COMMENTS_UPDATE', '<b>Comments & Directions to Complete Your Return:</b>' . "\n" . "%s\n");
define('EMAIL_TEXT_RETURNS_NUMBER', '<b>Return Request:</b>');
define('EMAIL_TEXT_RETURNS_URL', '<b>View Details:</b>');
define('EMAIL_TEXT_DATE_RETURNED', '<b>Return Request Date:</b>');
define('EMAIL_TEXT_RESOLUTION', 'Resolution: ');

define('BUTTON_TEXT_RESTOCK_TOTAL', 'Deduct %s&#37; Restocking Fee');
define('BUTTON_TEXT_RESTOCK_FULL_TOTAL', 'No Restocking Fee');
define('TEXT_DEDUCTION_AMOUNT', ' (Original price was %s, %s has been deducted)');
define('TEXT_CAN_BE_CHANGED', ' (This can be altered if order hasn\'t been finalised yet)');
define('TEXT_CANNOT_BE_CHANGED', ' (Return has been finalised)');
define('TEXT_FINALISE_RETURN', ' Finalise this return?<br><small> </strong>(refund amount and method will no longer be able to be altered)<strong></small>');
define('TEXT_NO_RETURN_HISTORY', 'No Return History Statuses');

define('ERROR_RETURN_DOES_NOT_EXIST', ' An error occurred. Please try again');

// text below will be inserted into javascript code so best to use <br> for line breaks - "\n", PHP_EOL, "\r\n" won't work
define('TEXT_COMMENT_RETURN_APPROVED', 'Your return request has been approved. Provided the item is in its original condition and packaging, you may ship the item back to us using the provided return shipping label. This label is attached to the packing slip that was included in the package. Shipment via a traceable method is highly recommended. <br><br> Please note that all returns must be received within 15 days of RMA issuance. Upon receipt of the returned item, store credit for the amount of the purchased item will be issued electronically to the email address that was provided when the order was placed.<br><br>');
define('TEXT_COMMENT_RETURN_REJECTED', 'Your return request has been declined.<br /><br />Please contact us for more information.');
define('TEXT_COMMENT_RETURN_CREDITED', 'Your return has been processed. We will send a separate message containing a store credit code, issued in exchange for your recent product return. <br /><br />You can redeem this code during checkout when placing your next order. Please let us know if you have any questions.<br><br>');
define('TEXT_COMMENT_RETURN_REFUNDED', 'Your account will be refunded and made in the same manner of your original payment. Your refund should appear within one or two billing statement cycles.<br><br>');
define('TEXT_COMMENT_RESTOCK_APPLIED', 'A restocking fee of %s has been charged.<br /><br />');
?>
