<?php
/**
  * RMA Return System for osCommerce Online Merchant
  *
  * Author: frankl
  *
  * Portions @copyright (c) 2017 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */

  require('includes/application_top.php');

   $rma_value_query = tep_db_query("select * from configuration where configuration_key = 'RMA_RETURN_SYSTEM'");
   if (!tep_db_num_rows($rma_value_query)) {
	   tep_redirect(tep_href_link('returns_configuration.php?action=install_new'));	   
   } 
  
  require('includes/classes/currencies.php');
  $currencies = new currencies();

  if ($_GET['action'] == 'return_new' && !$_POST['products_id']){
      $messageStack->add_session(WARNING_SELECT_PRODUCT_ID, 'warning');
	  tep_redirect(tep_href_link('return_create.php', 'orders_id=' . $_GET['orders_id'] . '&action=new'));
  }
  
  if ($_GET['products_id']) {
	  $products_id = $_GET['products_id'];
  } else if ($_POST['products_id']) {
	  $products_id = $_POST['products_id'];
  } else {
	  $products_id = '';
  }

  require('includes/classes/order.php');
  $order = new order($_GET['orders_id']);
  
  // check if order is in the allowed status for return
  $order_status_id_query = tep_db_query("select orders_status from orders where orders_id = '" . (int)$_GET['orders_id'] . "'");
  $order_status_id = tep_db_fetch_array($order_status_id_query);  
  $return_order_status_query = tep_db_query("select * from returns_configuration where returns_order_statuses = '" . (int)$order_status_id['orders_status'] . "'");
	if (!tep_db_num_rows($return_order_status_query)) {
		$error_text .= TEXT_ERROR_INCORRECT_STATUS;
	}
	
  // check if the order is within the time limit allowed for returns
  $limit_date = strtotime ( '+' . DAYS_FOR_REFUND . ' days', strtotime ($order->info['date_purchased']));
  $today = strtotime('today');
	if ($limit_date < $today) {
	  $error_text .= sprintf(TEXT_ERROR_BEYOND_STORE_RETURN_LIMIT, DAYS_FOR_REFUND);
	}

 // check to find out what the default reason & refund method for returning a product is
 $default_priority_query = tep_db_query("SELECT configuration_value FROM configuration where configuration_key = 'DEFAULT_RETURN_REASON'");
 $default_priority = tep_db_fetch_array($default_priority_query);
 $default_refund_query = tep_db_query("SELECT configuration_value FROM configuration where configuration_key = 'DEFAULT_REFUND_METHOD'");
 $default_refund = tep_db_fetch_array($default_refund_query);
 
 //create a random easily remembered return number
 function tep_create_rma_value($length) {
	$chars = '23456789ABCDEFGHJKLMNPQRSTUVWXYZ';
	$rand_rma = '';
	for ($i = 0; $i < $length; $i++) {
      $rand_rma .= $chars[mt_rand(0, strlen($chars)-1)];
	}
	$pass = false;
	while (!$pass) {
	  $rma_value_check_query = tep_db_query("select rma_value from returned_products where rma_value = '" . $rand_rma . "'");
	  if (!tep_db_num_rows($rma_value_check_query)) {
        $pass = true;
	  } else {
		for ($i = 0; $i < $length; $i++) {
		  $rand_rma .= $chars[mt_rand(0, strlen($chars)-1)];
		}  
	  }
	}
	return $rand_rma;
  }


  if (!$_POST['action']){
      $_POST['action'] = 'new';
  }

  if ($_GET['action']) {

    switch ($_GET['action']) {
      case 'insert':
      case 'update':
         // carry out a query on all the existing orders tables, to get the required information
         $rma_create = tep_create_rma_value(5);
         $returns_status_query = tep_db_query("SELECT configuration_value FROM configuration where configuration_key = 'DEFAULT_RETURN_STATUS_ID'");
         $default_return = tep_db_fetch_array($returns_status_query);
         $order_returns_query = tep_db_query("SELECT * FROM orders o, orders_products op where o.orders_id = op.orders_id and o.orders_id = '" . (int)$_GET['orders_id'] . " ' and op.products_id = '" . (int)$products_id . "'");
         $orders_return = tep_db_fetch_array($order_returns_query);
		 


         if ($_POST['returns_quantity'] > $orders_return['products_quantity']) {
			 $messageStack->add_session(TEXT_RETURNS_ERROR_QUANTITY, 'warning');
			 tep_redirect(tep_href_link('return_create.php', 'action=return_new&orders_id=' . (int)$_GET['orders_id'] . '&products_id=' . (int)$products_id), 'SSL');

         }

         $rma_value = tep_db_prepare_input($rma_create);
		 $email_link = tep_href_link('returns_track.php', '', 'SSL', false);
         $orders_id = $_GET['orders_id'];
         $customers_email = $_POST['user_email'];
		 $customers_id = $orders_return['customers_id'];
         $comments = tep_db_prepare_input($_POST['support_text']);
		 $admin_comments = tep_db_prepare_input($_POST['admin_text']);
         $returns_status =  $default_return['configuration_value'];
         $return_reason_id = tep_db_prepare_input($_POST['return_reason_id']);
		 $final_price = $final_price = tep_add_tax($orders_return['final_price'] * $_POST['returns_quantity'], $orders_return['products_tax'], true);
         $products_quantity = $_POST['returns_quantity'];
		 if (tep_not_null($orders_return['products_serial_number'])) {
			 $serial_number = $orders_return['products_serial_number'];
		 } else {
			 $serial_number = tep_db_prepare_input($_POST['products_serial_number']);
		 }
         $refund_method = $_POST['refund_method'];
         $support_error = false;
 // error checking elsewhere in code

   if (!$support_error = false) {
	   
          $sql_data_array = array('customers_id' => $customers_id,
                                  'rma_value' => $rma_value,
                                  'orders_id' => $orders_id,
                                  'returns_status' => $returns_status,
                                  'return_reason_id' => $return_reason_id,
								  'products_id' => $products_id,
								  'products_quantity' => $products_quantity,
								  'products_serial_number' => $serial_number,
                                 );
          if ($_GET['action'] == 'insert') {
			  

		 
			$total_ordered_query = tep_db_query("select products_quantity from orders_products where products_id = '" . (int)$_GET['products_id'] . "' and orders_id = '" . $_GET['orders_id'] . "'");
			$total_ordered = tep_db_fetch_array($total_ordered_query);
			$total_products_query = tep_db_query("select sum(products_quantity) as total FROM returned_products where products_id = '" . (int)$_GET['products_id'] . "' and orders_id = '" . $_GET['orders_id'] . "'");
            $total_products = tep_db_fetch_array($total_products_query);
				if (($_POST['returns_quantity'] + $total_products['total']) >= $total_ordered['products_quantity']+1) {
				  $messageStack->add_session(TEXT_RETURNS_ALREADY_RETURNED, 'warning');
				  tep_redirect(tep_href_link('return_create.php', 'action=return_new&orders_id=' . (int)$_GET['orders_id'] . '&products_id=' . (int)$products_id), 'SSL');
				}
			
			$insert_sql_data = array('date_added' => 'now()');

            tep_db_perform('returned_products', $sql_data_array);
            $returns_id = tep_db_insert_id();

            tep_db_perform('returned_products', $insert_sql_data, 'update', 'returns_id = \'' . $returns_id . '\'');

            $returns_payment_sql = array('returns_id' => $returns_id,
                                       'refund_payment_name' => '',
                                       'refund_payment_value' => $final_price,
									   'customer_method' => $refund_method
                                       );

            tep_db_perform('refund_payments', $returns_payment_sql);

          }

		  // Add returns status to returns status history table
		  tep_db_query("insert into returns_status_history (returns_id , returns_status_id, date_added, customer_notified, comments) values ('" . $returns_id . "','" .   $returns_status . "', now(), 1,'" . tep_db_input($comments) . "')");
		  if ($admin_comments != '') {
			  tep_db_query("insert into returns_status_history (returns_id , returns_status_id, date_added, customer_notified, comments) values ('" . $returns_id . "', '6', now(), 0,'" . tep_db_input($admin_comments) . "')");
		  }
		  
          // now send email to customer

           require(DIR_FS_CATALOG . 'includes/languages/' . $language . '/return_emails.php');
           $email_text = EMAIL_TEXT_RETURNS_TITLE;
           $email_text .= EMAIL_TEXT_RETURNS_THANKS . EMAIL_TEXT_RETURNS_SENT . EMAIL_TEXT_RETURNS_CLOSE . EMAIL_TEXT_RETURNS_CONTACT_OPEN . EMAIL_TEXT_RETURNS_WARNING;
           tep_mail($customers_name, $customers_email, EMAIL_TEXT_RETURNS_SUBJECT . ' #' . $rma_value, nl2br($email_text), STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

          // now send an email to the default administrator to let them know of new return
             $email_text_admin = EMAIL_TEXT_RETURNS_THANKS_ADMIN . EMAIL_TEXT_RETURNS_ADMIN;
             tep_mail(STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS , EMAIL_TEXT_RETURNS_SUBJECT_ADMIN .' ' . $rma_value, nl2br($email_text_admin), STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

          // redirect to confirmation
            tep_redirect(tep_href_link('return_create.php' . '?action=sent&rma_value='. $rma_value . '&return_id=' . $returns_id . '&orders_id=' . $orders_id));
        } else {
          $_GET['action'] = 'new';
        }
        break;
       case 'default':
       tep_redirect(tep_href_link('index.php'));
       break;
    }
  }

  require('includes/template_top.php');
?>

    <table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr>
        <td width="100%"><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td class="pageHeading"><?php echo HEADING_TITLE; ?></td>
            <td class="pageHeading" align="right"><?php echo tep_draw_separator('pixel_trans.gif', HEADING_IMAGE_WIDTH, HEADING_IMAGE_HEIGHT); ?></td>
          </tr>
        </table></td>
      </tr>
	  <?php 
	  if($error_text) {
	  ?>
      <tr>
        <td width="100%"><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td class="errorText"><?php echo HEADING_WARNING . $error_text; ?></td>
          </tr>
        </table></td>
      </tr>
	  <?php 
	  }
	  ?>
	<?php
	  if ($_GET['action'] == 'sent'){
        $account_query = tep_db_query("SELECT customers_email_address from orders where orders_id = '" . (int)$_GET['orders_id'] . "'");
        $account = tep_db_fetch_array($account_query);
		$customers_email_address = $account['customers_email_address'];
		$customers_first_name = $account['customers_firstname'];
     ?>
      <tr>
	    <td><?php echo TEXT_RETURNS_YOUR_RMA_NUMBER . '<strong>' . $_GET['rma_value'] . '</strong>'; ?><td>
	  </tr> 
	  <tr>
	    <td><?php echo sprintf(TEXT_RETURNS_SUCCESS, $account['customers_email_address']); ?><td>
	  </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>
      <tr>
        <td align="right" class="smallText"><?php echo tep_draw_button(IMAGE_CANCEL, 'close', tep_href_link('orders.php', 'oID=' . $_GET['oID'] . '&action=edit#section_returns')); ?></td>
      </tr>
      <?
	  } else if ($_GET['action'] == 'return_new'){
        $account_query = tep_db_query("SELECT customers_firstname, customers_lastname, customers_email_address FROM customers where customers_id = '" . $customer_id . "'");
        $account = tep_db_fetch_array($account_query);
        // query the order table, to get all the product details
        $returned_products_query = tep_db_query("SELECT * FROM orders_products op, orders o where o.orders_id = op.orders_id and op.orders_id = '" . $_GET['orders_id'] . "' and products_id = '" . $products_id . "'");
        $returned_products = tep_db_fetch_array($returned_products_query);
	  ?>
      <?php echo tep_draw_form('longsubmit', 'return_create.php?action=insert&orders_id=' . $_GET['orders_id'] . '&products_id=' . $products_id, 'post'); ?>
	<tr>
	  <td><h2><?php echo sprintf(TEXT_RETURNS_HEADING, $_GET['orders_id']); ?></h2></td>
	</tr>
	<tr>
      <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
    </tr>
	<tr>
	  <td>
	    <table border="0" width="50%" cellspacing="0" cellpadding="5">
		  <tr class="dataTableHeadingRow">
			<td class="dataTableHeadingContent"><?php echo HEADING_RETURNS_QUANTITY; ?></td>
			<td class="dataTableHeadingContent"><?php echo HEADING_RETURNS_PRODUCTS; ?></td>
			<td class="dataTableHeadingContent"><?php echo HEADING_RETURNS_TOTAL; ?></td>
		  </tr>
		  <tr>
			<td><?php 
					$total_products_query = tep_db_query("select sum(products_quantity) as total FROM returned_products where products_id = '" . $products_id . "' and orders_id = '" . $_GET['orders_id'] . "'");
					$total_products = tep_db_fetch_array($total_products_query);
					$returnable = $returned_products['products_quantity'] - $total_products['total'];
					if ($returnable < '2') {
					  echo tep_draw_hidden_field('returns_quantity', '1') . '1';
					} else {
					  echo tep_draw_input_field('returns_quantity', '1', 'required aria-required="true" id="returns_quantity" placeholder="1"');
					}
					?></td>
			<td><?php echo $returned_products['products_name']; 
						if ($returned_products['products_quantity'] > '1') {
							echo '<br /><small><em>(' . $returnable . ' can be returned)</em></small>';
						}
				?></td>
			<td><?php echo $currencies->format($returned_products['final_price'], true, $returned_products['currency'], $returned_products['currency_value']); ?></td>
		  </tr>	  
		</table>
	  </td>
	</tr>
	<tr>
	  <td><?php echo tep_draw_separator('pixel_black.gif', '50%', '1'); ?></td>
	</tr>	
	<tr>
      <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '20'); ?></td>
    </tr>
	<tr>
        <td><table border="0" width="100%" cellspacing="0" cellpadding="5">	  
		  <?php
		  if (RETURNS_SHOW_SERIAL_NUMBER == '1') {
		  ?>
		  <tr>
			<td class="main" valign="top" width="180"><strong><?php echo TEXT_RETURNS_SERIAL_NUMBER; ?></strong></td>
			<td><?php echo tep_draw_input_field('products_serial_number', $orders_return['products_serial_number']); ?></td>
		  </tr>
		  <?php
			}
		  ?>
          <tr>
            <td class="main" valign="top" width="180"><strong><?php echo TEXT_RETURNS_DELIVERY_ADDRESS; ?></strong></td>
            <td><?php echo tep_address_format($order->billing['format_id'], $order->billing, 1, ' ', '<br>'); ?></td>
          </tr>
          <tr>
            <td colspan="2"><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
          </tr>
          <tr>
            <td class="main" valign="top" width="140"><strong><?php echo TEXT_RETURNS_USER_EMAIL; ?></strong></td>
            <td><?php echo $order->customer['email_address'] . tep_draw_hidden_field('user_email', $order->customer['email_address']); ?></td>
          </tr>
          <tr>
            <td colspan="2"><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
          </tr>
          <tr>
            <td class="main" valign="top" width="140"><strong><?php echo TEXT_RETURNS_WHY_RETURN; ?></strong></td>
            <td class="main"><?php
			$priority_array = array();
            $priority_query = tep_db_query("select return_reason_id, return_reason_name from return_reasons where language_id = '" . $languages_id . "' order by return_reason_id desc");
            while ($priority_values = tep_db_fetch_array($priority_query)) {
              $priority_array[] = array('id' => $priority_values['return_reason_id'], 
										'text' => substr($priority_values['return_reason_name'], 0, MAX_DISPLAY_MANUFACTURER_NAME_LEN));
            }
            echo tep_draw_pull_down_menu('return_reason_id', $priority_array, $default_priority['configuration_value'], 'id="return_reason_id" aria-describedby="returnReason"');
			?></td>
          </tr>
          <tr>
            <td colspan="2"><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
          </tr>
          <tr>
            <td class="main" valign="top" width="140"><strong><?php echo TEXT_RETURNS_PREF_REFUND_METHOD; ?></strong></td>
            <td class="main"><?php
			$refund_array = array();
            $refund_query = tep_db_query("select refund_method_id, refund_method_name from refund_method where language_id = '" . $languages_id . "' order by refund_method_id asc");
            while ($refund_values = tep_db_fetch_array($refund_query)) {
              $refund_array[] = array('id' => $refund_values['refund_method_id'], 
										'text' => substr($refund_values['refund_method_name'], 0, MAX_DISPLAY_MANUFACTURER_NAME_LEN));
            }
            echo tep_draw_pull_down_menu('refund_method', $refund_array, $default_refund['configuration_value'], 'id="refund_method" aria-describedby="refundMethod"');
			?></td>
          </tr>
          <tr>
            <td colspan="2"><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
          </tr>
		  <?php
			$charge_query = tep_db_query("SELECT configuration_value FROM configuration where configuration_key = 'DEFAULT_RESTOCK_VALUE'");
			$charge = tep_db_fetch_array($charge_query);
			  if ($charge['configuration_value'] != 0) {
				echo '<tr><td><strong>' . TEXT_RETURNS_SURCHARGE_WARNING . '</strong><td>' . sprintf(TEXT_RETURNS_SURCHARGE, $charge['configuration_value'] . '%') . '</td></tr><tr><td colspan="2">' . tep_draw_separator('pixel_trans.gif', '1', '10') . '</td></tr>';
			  } 
		  ?>
          <tr>
            <td class="main" valign="top" width="140"><strong><?php echo TEXT_RETURNS_TEXT; ?></strong></td>
            <td><?php echo tep_draw_textarea_field('support_text', 'soft', 60, 5, $comments, 'id="inputComments" placeholder="' . TEXT_RETURNS_COMMENTS . '"'); ?></td>
          </tr>
          <tr>
            <td colspan="2"><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
          </tr>		  
          <tr>
            <td class="main" valign="top" width="140"><strong><?php echo TEXT_RETURNS_TEXT_ADMIN; ?></strong></td>
            <td><?php echo tep_draw_textarea_field('admin_text', 'soft', 60, 5, $comments, 'id="inputCommentsAdmin" placeholder="' . TEXT_RETURNS_COMMENTS_ADMIN . '"'); ?></td>
          </tr>
          <tr>
            <td colspan="2"><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>
      <tr>
        <td><?php echo tep_draw_button(BUTTON_RETURNS_SUBMIT, 'disk', null, 'primary'); ?>&nbsp;<?php echo tep_draw_button(IMAGE_BACK, 'triangle-1-w', tep_href_link('return_create.php', 'orders_id=' . $_GET['orders_id'] . '&action=new')); ?></td>
      </tr>
      </form>
<?php
} else {
?>
      <tr>
        <td><h2><?php echo TEXT_RETURNS_SELECT_PRODUCT; ?></h2></td>
      </tr>
	  <tr>
		<td colspan="2"><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
	  </tr>
	  <?php echo tep_draw_form('product_return', 'return_create.php', 'action=return_new&orders_id=' . $_GET['orders_id'], 'post'); ?>
	  <tr>
	    <td>
		  <table border="0" width="100%" cellspacing="0" cellpadding="5">
			<tr class="dataTableHeadingRow">
			  <td class="dataTableHeadingContent"><?php echo HEADING_RETURNS_SELECT; ?></td>
			  <td class="dataTableHeadingContent"><?php echo HEADING_RETURNS_PRODUCTS; ?></td>
			  <td class="dataTableHeadingContent"><?php echo HEADING_RETURNS_ORIGINAL_QTY; ?></td>
			</tr>
			<tr>
			  <td><?php
				  $total_returnable = '0';
			      $orders_products_query = tep_db_query("select products_id, products_name, products_model, products_price, products_tax, products_quantity, final_price from " . TABLE_ORDERS_PRODUCTS . " where orders_id = '" . (int)$_GET['orders_id'] . "'");
					while ($orders_products = tep_db_fetch_array($orders_products_query)) {
					  
					  $attributes_query = tep_db_query("select products_options, products_options_values, options_values_price, price_prefix from " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . " where orders_id = '" . (int)$_GET['orders_id'] . "' and orders_products_id = '" . (int)$orders_products['orders_products_id'] . "'");
					  $total_products_query = tep_db_query("select sum(products_quantity) as total from returned_products where products_id = '" . $orders_products['products_id'] . "' and orders_id = '" . $_GET['orders_id'] . "'");
					  $total_products = tep_db_fetch_array($total_products_query);
					  if ($total_products['total'] < $orders_products['products_quantity']) {
						$total_returnable = $total_returnable+1;
						echo '		  <tr class="dataTableRow" onmouseover="rowOverEffect(this)" onmouseout="rowOutEffect(this)">' . "\n" .
							 '            <td class="dataTableContent">' . tep_draw_radio_field('products_id', $orders_products['products_id'], false, 'required') . "\n" .
							 '            <td class="dataTableContent">&nbsp;&nbsp;' . $orders_products['products_name'] . '&nbsp;&nbsp;' . "\n";


						if (tep_db_num_rows($attributes_query)) {
						  while ($attributes = tep_db_fetch_array($attributes_query)) {
							echo '<br /><nobr><small>&nbsp;<i> - ' . $attributes['products_option'] . ': ' . $attributes['products_options_values'] . '</i></small></nobr>';
						  }
						}
						echo '			<td class="dataTableContent">' . $orders_products['products_quantity'] . '</td>' . "\n" .
							 '		  </tr>' . "\n";

					  } else {
						echo '		  <tr class="dataTableRow" onmouseover="rowOverEffect(this)" onmouseout="rowOutEffect(this)">' . "\n" .
							 '            <td class="dataTableContent"><small><em>' . TEXT_RETURNS_ALREADY_RETURNED . '</em></small>' . "\n" .
							 '            <td class="dataTableContent">&nbsp;&nbsp;' . $orders_products['products_name'] . "\n";
							 
						  if (tep_db_num_rows($attributes_query)) {
						    while ($attributes = tep_db_fetch_array($attributes_query)) {
							  echo '<br /><nobr><small>&nbsp;<i> - ' . $attributes['products_option'] . ': ' . $attributes['products_options_values'] . '</i></small></nobr>';
						    }
						  }
						echo '			<td class="dataTableContent">' . $orders_products['products_quantity'] . '</td>' . "\n" .				  
							 '		  </tr>' . "\n";	
					  }					 

					}
		  ?></td>
			</tr>
          <tr>
            <td colspan="2"><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>
      <tr>
        <td><?php if($total_returnable > '0') { echo tep_draw_button(BUTTON_RETURNS_SUBMIT, 'disk', null, 'primary'); } ?>&nbsp;<?php echo tep_draw_button(IMAGE_BACK, 'triangle-1-w', tep_href_link('orders.php', 'oID=' . $_GET['orders_id'] . '&action=edit')); ?></td>
      </tr>
      </form>
<?php
}
?>	  
      </tr>
    </table>

<?php
  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>
