<?php
/**
  * RMA Return System for osCommerce Online Merchant
  *
  * Author: frankl
  *
  * Portions @copyright (c) 2017 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */

  require('includes/application_top.php');
   
   $rma_value_query = tep_db_query("select * from configuration where configuration_key = 'RMA_RETURN_SYSTEM'");
   if (!tep_db_num_rows($rma_value_query)) {
	   tep_redirect(tep_href_link('returns_configuration.php?action=install_new'));	   
   } 
  $OSCOM_Hooks->register('returns');

  require('includes/classes/currencies.php');
  $currencies = new currencies();
  
  $returns_statuses = array();
  $returns_status_array = array();
  $returns_status_query = tep_db_query("select returns_status_id, returns_status_name from returns_status where language_id = '" . $languages_id . "'");
  while ($returns_status = tep_db_fetch_array($returns_status_query)) {
    $returns_statuses[] = array('id' => $returns_status['returns_status_id'],
                               'text' => $returns_status['returns_status_name']);
    $returns_status_array[$returns_status['returns_status_id']] = $returns_status['returns_status_name'];
  }
  
  $refunds_methods = array();
  $refund_methods_array = array();
  $refund_methods_query = tep_db_query("select refund_method_id, refund_method_name from refund_method where language_id = '" . $languages_id . "'");
  while ($refund_methods = tep_db_fetch_array($refund_methods_query)) {
    $refunds_methods[] = array('id' => $refund_methods['refund_method_id'],
                               'text' => $refund_methods['refund_method_name']);
    $refund_methods_array[$refund_methods['refund_method_id']] = $refund_methods['refund_method_name'];
  }
  
  $reasons = array();
  $reason_array = array();
  $reason_query = tep_db_query("select return_reason_id, return_reason_name from return_reasons where language_id = '" . $languages_id . "'");
  while ($reason = tep_db_fetch_array($reason_query)) {
    $reasons[] = array('id' => $reason['return_reason_id'],
                               'text' => $reason['return_reason_name']);
    $reason_array[$reason['return_reason_id']] = $reason['return_reason_name'];
  }

  $action = (isset($_GET['action']) ? $_GET['action'] : '');

  if (tep_not_null($action)) {
    switch ($action) {
      case 'update_order':
 		
		$rID = $_GET['rID'];
		$oID = $_GET['oID'];
		
		$return_updated = false;
		
		$returns_info_query = tep_db_query("select returns_id, customers_id, rma_value, orders_id, last_modified, date_added, returns_status, returns_date_finished, return_reason_id, products_id, products_quantity, products_serial_number, products_returned, contact_user_name from returned_products where returns_id = '" . (int)$rID . "'");
		$returns_info = tep_db_fetch_array($returns_info_query);
		
		$refund_payment_info_query = tep_db_query("select refund_payment_name, refund_payment_value, refund_payment_date, refund_payment_reference, refund_payment_deductions, customer_method, refund_payment_finalised from refund_payments where returns_id = '" . (int)$rID . "'");
		$refund_payment_info = tep_db_fetch_array($refund_payment_info_query);
		
		$customer_info_query = tep_db_query("select o.customers_name, o.customers_email_address, rp.returns_status, rp.date_added from returned_products rp, orders o where rp.returns_id = '" . tep_db_input($rID) . "' and rp.orders_id = o.orders_id");
		$customer_info = tep_db_fetch_array($customer_info_query);
		
		$rID = tep_db_prepare_input($_GET['rID']);
		$oID = tep_db_prepare_input($_GET['oID']);
        $status = tep_db_prepare_input($_POST['status']);
        $comments = tep_db_prepare_input($_POST['comments']);
		$reason = tep_db_prepare_input($_POST['reason']);
		$payment_method = $_POST['refund_method'];
        $payment_ref = $_POST['refund_reference'];
        $payment_date = $_POST['refund_date'];
		$refund_payment_value = $_POST['refund_amount'];
		$products_id = $returns_info['products_id'];
		$rma_number = $returns_info['rma_value'];
		$returns_products_query = tep_db_query("select products_tax, final_price from orders_products where orders_id = '" . (int)$returns_info['orders_id'] . "' and products_id = '" . $products_id . "'");
		$returns_products = tep_db_fetch_array($returns_products_query);
		$total_return_value = tep_add_tax(($returns_products['final_price'] * $returns_info['products_quantity']), $returns_products['products_tax'], true);
			
		
		if ($_POST['refund_amount'] < $total_return_value) {
		  $work_out_charge = $total_return_value - $_POST['refund_amount'];
		}
		
		if ($refund_payment_info['refund_payment_finalised'] == '1' || $_POST['finalised'] == '1') {
		  $finalised = '1';
		  $refund_name = $refund_payment_info['refund_payment_name'];
		} else {
		  $finalised = '0';
		  $refund_name = '';
		}

	  /// Finalising the return?		
		if ($_POST['finalised'] == '1') {
		  $refund_name_query = tep_db_query("select refund_method_name from refund_method where refund_method_id = '" . (int)$_POST['refund_method'] . "' and language_id = '" . $languages_id . "'");
		  $refund_name_array = tep_db_fetch_array($refund_name_query);
		  $refund_name = $refund_name_array['refund_method_name'];
		  $comments = EMAIL_TEXT_RESOLUTION . $refund_name . "\n\n";
		  tep_db_query("update returned_products set returns_status = '" . RETURNS_CLOSED_TRANSACTIONS_ORDER_STATUS_ID . "' where returns_id = '" . (int)$rID . "'");

	  
		  $email = STORE_NAME . "\n" . EMAIL_SEPARATOR . "\n" . EMAIL_TEXT_RETURNS_NUMBER . ' ' . $returns_info['rma_value'] . "\n" . EMAIL_TEXT_RETURNS_URL . ' ' . tep_catalog_href_link('returns_track.php', 'action=returns_show&rma=' . $returns_info['rma_value'], 'SSL') . "\n" . EMAIL_TEXT_DATE_RETURNED . ' ' . tep_date_long($customer_info['date_added']) . "\n\n" . $comments . sprintf(EMAIL_TEXT_STATUS_UPDATE, $returns_status_array[$status]);

          tep_mail($customer_info['customers_name'], $customer_info['customers_email_address'], EMAIL_TEXT_SUBJECT . ' ' . $returns_info['rma_value'], $email, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

		  $return_comment = EMAIL_TEXT_RESOLUTION . ': ' . $refund_name . "\n";
          $returns_data_array = array('returns_id' => $rID,
									  'returns_status_id' => RETURNS_PAYPAL_TRANSACTIONS_ORDER_STATUS_ID,
									  'date_added' => 'now()',
									  'customer_notified' => '0',
									  'comments' => $return_comment);
          tep_db_perform('returns_status_history', $returns_data_array);
			
			
		  $customer_return_comment = 'Your return has been completed' . "\n" .
									   EMAIL_TEXT_RESOLUTION . ': ' . $refund_name . "\n";
          $customer_returns_data_array = array('returns_id' => $_GET['rID'],
											   'returns_status_id' => RETURNS_CLOSED_TRANSACTIONS_ORDER_STATUS_ID,
											   'date_added' => 'now()',
											   'customer_notified' => '1',
											   'comments' => $customer_return_comment);
          tep_db_perform('returns_status_history', $customer_returns_data_array);

         $messageStack->add_session(SUCCESS_RETURN_CLOSED, 'success');
		 $return_updated = true;
			
		} else {
		
		  if ($returns_info['returns_status'] != $status) {
            tep_db_query("update returned_products set returns_status = '" . tep_db_input($status) . "', last_modified = now() where returns_id = '" . (int)$rID . "'");
		  }
		  $customer_notified = '0';
          $notify_comments = '';
            if (isset($_POST['notify_comments']) && ($_POST['notify_comments'] == 'on')) {
			  $notify_comments = sprintf(EMAIL_TEXT_COMMENTS_UPDATE, $comments) . "\n\n";
			}

          $email = STORE_NAME . "\n" . EMAIL_SEPARATOR . "\n" . EMAIL_TEXT_RETURNS_NUMBER . ' ' . $rma_number . "\n\n" . EMAIL_TEXT_RETURNS_URL . ' ' . tep_catalog_href_link('returns_track.php', 'action=returns_show&rma=' . $returns_info['rma_value'], 'SSL') . "\n\n" . EMAIL_TEXT_DATE_RETURNED . ' ' . tep_date_long($customer_info['date_added']) . "\n\n" . $notify_comments . sprintf(EMAIL_TEXT_STATUS_UPDATE, $returns_status_array[$status]);

          tep_mail($customer_info['customers_name'], $customer_info['customers_email_address'], EMAIL_TEXT_SUBJECT . ' ' . $returns_info['rma_value'], $email, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

          $customer_notified = '1';

          tep_db_query("insert into returns_status_history (returns_id, returns_status_id, date_added, customer_notified, comments) values ('" . (int)$rID . "', '" . tep_db_input($status) . "', now(), '" . tep_db_input($customer_notified) . "', '" . tep_db_input($comments)  . "')");
			  
		  $return_updated = true;
        }
			
		$refund_data_array = array('refund_payment_name' => $refund_name,
								     'customer_method' => $payment_method,
                                     'refund_payment_value' => $refund_payment_value,
                                     'refund_payment_date' => 'now()',
                                     'refund_payment_reference' => $payment_ref,
                                     'refund_payment_deductions' => $work_out_charge,
								     'refund_payment_finalised' => $finalised);
		tep_db_perform('refund_payments', $refund_data_array,  'update', 'returns_id = ' . $rID . '');
		  
		if ($_POST['restock_products'] == 'on') {
		
		  if ($return->products['products_returned'] != '1') {		
            tep_db_query("update products set products_quantity = products_quantity + '" . $returns_info['products_quantity'] . "' where products_id = '" . $products_id . "'");
		    tep_db_query("update returned_products set products_returned = '1' where products_id = '" . $products_id . "' and returns_id = '" . $rID . "'");
            $return_updated = true;
            $messageStack->add_session(SUCCESS_PRODUCT_TO_STOCK, 'success');
		  }
		}
	  
	    if ( $returns_info['return_reason_id'] != $reason) {
          tep_db_query("update returned_products set return_reason_id = '" . tep_db_input($reason) . "', last_modified = now() where returns_id = '" . (int)$rID . "'");
		  $return_updated = true;
	    }

	    if ($return_updated == true) {
		  $messageStack->add_session(SUCCESS_RETURN_UPDATED, 'success');
        } else {
		  $messageStack->add_session(WARNING_RETURN_NOT_UPDATED, 'warning');
        }
        tep_redirect(tep_href_link('returns.php', 'oID=' . $oID . '&rID=' . $rID . '&action=edit&id=' . $products_id));
        break;
      case 'deleteconfirm':
        $rID = tep_db_prepare_input($_GET['rID']);

        tep_db_query("delete from refund_payments where returns_id = '" . (int)$rID . "'");
		tep_db_query("delete from returned_products where returns_id = '" . (int)$rID . "'");
		tep_db_query("delete from returns_status_history where returns_id = '" . (int)$rID . "'");

        tep_redirect(tep_href_link('returns.php', tep_get_all_get_params(array('rID', 'action'))));
        break;
    }
  }

  if (($action == 'edit') && isset($_GET['rID'])) {
    $rID = tep_db_prepare_input($_GET['rID']);

    $returns_query = tep_db_query("select returns_id from returned_products where returns_id = '" . (int)$rID . "'");
    $return_exists = true;
    if (!tep_db_num_rows($returns_query)) {
      $return_exists = false;
      $messageStack->add(sprintf(ERROR_RETURN_DOES_NOT_EXIST, $rID), 'error');
    }
  }

  if (!function_exists('tep_draw_button')) { // v2.2rc2a compatibility
    function tep_draw_button($title = null, $icon = null, $link = null, $priority = null, $params = null) {
      static $button_counter = 1;

      $types = array('submit', 'button', 'reset');

      if ( !isset($params['type']) ) {
        $params['type'] = 'submit';
      }

      if ( !in_array($params['type'], $types) ) {
        $params['type'] = 'submit';
      }

      if ( ($params['type'] == 'submit') && isset($link) ) {
        $params['type'] = 'button';
      }

      if (!isset($priority)) {
        $priority = 'secondary';
      }

      $button = '<span class="tdbLink">';

      if ( ($params['type'] == 'button') && isset($link) ) {
        $button .= '<a id="tdb' . $button_counter . '" href="' . $link . '"';

        if ( isset($params['newwindow']) ) {
          $button .= ' target="_blank"';
        }
      } else {
        $button .= '<button id="tdb' . $button_counter . '" type="' . tep_output_string($params['type']) . '"';
      }

      if ( isset($params['params']) ) {
        $button .= ' ' . $params['params'];
      }

      $button .= '>' . $title;

      if ( ($params['type'] == 'button') && isset($link) ) {
        $button .= '</a>';
      } else {
        $button .= '</button>';
      }

      $button .= '</span><script type="text/javascript">$("#tdb' . $button_counter . '").button(';

      $args = array();

      if ( isset($icon) ) {
        if ( !isset($params['iconpos']) ) {
          $params['iconpos'] = 'left';
        }

        if ( $params['iconpos'] == 'left' ) {
          $args[] = 'icons:{primary:"ui-icon-' . $icon . '"}';
        } else {
          $args[] = 'icons:{secondary:"ui-icon-' . $icon . '"}';
        }
      }

      if (empty($title)) {
        $args[] = 'text:false';
      }

      if (!empty($args)) {
        $button .= '{' . implode(',', $args) . '}';
      }

      $button .= ').addClass("ui-priority-' . $priority . '").parent().removeClass("tdbLink");</script>';

      $button_counter++;

      return $button;
    }
  }

  include(DIR_FS_CATALOG . 'includes/classes/returns.php');

  $OSCOM_Hooks->call('returns', 'returnsAction');

  require('includes/template_top.php');

  $base_url = ($request_type == 'SSL') ? HTTPS_SERVER . DIR_WS_HTTPS_ADMIN : HTTP_SERVER . DIR_WS_ADMIN;
?>

<script>
// v2.2rc2a compatibility
if ( typeof jQuery == 'undefined' ) {
  document.write('<scr' + 'ipt src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></scr' + 'ipt>');
}
</script>

<script>
if ( typeof jQuery.ui == 'undefined' ) {
  document.write('<link rel="stylesheet" href="https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.4/themes/redmond/jquery-ui.css" />');
  document.write('<scr' + 'ipt src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.4/jquery-ui.min.js"></scr' + 'ipt>');

/* Custom jQuery UI */
  document.write('<style>.ui-widget { font-family: Lucida Grande, Lucida Sans, Verdana, Arial, sans-serif; font-size: 11px; } .ui-dialog { min-width: 500px; }</style>');
}
</script>

<?php
  if (($action == 'edit') && ($return_exists == true)) {
    $return = new returns($rID);
	$oID = $return->info['orders_id'];
	
	$pref_refund_name_query = tep_db_query("SELECT refund_method_name FROM refund_method where refund_method_id = '" . (int)$return->info['customer_method'] . "' and language_id = '" . $languages_id . "'");
	$pref_refund_name = tep_db_fetch_array($pref_refund_name_query);
	  
?>

<h1 class="pageHeading"><?php echo HEADING_TITLE . ': #' . (int)$rID . ' (' . $return->info['returns_status_name'] . ')'; ?></h1>
<div style="text-align: right; padding-bottom: 15px;"><?php echo tep_draw_button(IMAGE_BACK, 'triangle-1-w', tep_href_link('returns.php', tep_get_all_get_params(array('action')))); ?></div>

<div id="returnTabs" style="overflow: auto;">
  <ul>
    <li><?php echo '<a href="' . substr(tep_href_link('returns.php', tep_get_all_get_params()), strlen($base_url)) . '#section_summary_content">' . TAB_TITLE_SUMMARY . '</a>'; ?></li>
    <li><?php echo '<a href="' . substr(tep_href_link('returns.php', tep_get_all_get_params()), strlen($base_url)) . '#section_products_content">' . TAB_TITLE_PRODUCTS . '</a>'; ?></li>
    <li><?php echo '<a href="' . substr(tep_href_link('returns.php', tep_get_all_get_params()), strlen($base_url)) . '#section_status_history_content">' . TAB_TITLE_STATUS_HISTORY . '</a>'; ?></li>
  </ul>

  <div id="section_summary_content" style="padding: 10px;">
    <table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr>
        <td width="33%" valign="top">
          <fieldset style="border: 0; height: 100%;">
            <legend style="margin-left: -20px; font-weight: bold;"><?php echo ENTRY_CUSTOMER; ?></legend>

            <p><?php echo tep_address_format($return->customer['format_id'], $return->customer, 1, '', '<br />'); ?></p>
            <p><?php echo $return->customer['telephone'] . '<br />' . '<a href="mailto:' . $return->customer['email_address'] . '"><u>' . $return->customer['email_address'] . '</u></a>'; ?></p>
          </fieldset>
        </td>
        <td width="33%" valign="top">
          <fieldset style="border: 0; height: 100%;">
            <legend style="margin-left: -20px; font-weight: bold;"><?php echo ENTRY_SHIPPING_ADDRESS; ?></legend>

            <p><?php echo tep_address_format($return->delivery['format_id'], $return->delivery, 1, '', '<br />'); ?></p>
          </fieldset>
        </td>
        <td width="33%" valign="top">
          <fieldset style="border: 0; height: 100%;">
            <legend style="margin-left: -20px; font-weight: bold;"><?php echo ENTRY_BILLING_ADDRESS; ?></legend>

            <p><?php echo tep_address_format($return->billing['format_id'], $return->billing, 1, '', '<br />'); ?></p>
          </fieldset>
        </td>
      </tr>
      <tr>
        <td width="33%" valign="top">
          <fieldset style="border: 0; height: 100%;">
            <legend style="margin-left: -20px; font-weight: bold;"><?php echo ENTRY_RETURN_DETAILS; ?></legend>

            <p><?php echo $return->info['payment_method']; ?></p>

            <table border="0" cellspacing="0" cellpadding="0">
              <tr>
				<td class="main"><b><?php echo TEXT_ORDER_NO; ?></b></td>
				<td class="main"><?php echo '<a href="' . tep_href_link("orders.php", 'oID=' . $return->info['orders_id'] . '&action=edit')  . '" target="_blank"><u>' . $return->info['orders_id']; ?></u></a></td>
			  </tr>
			  <!-- add Returns #  -->
			  <tr>
				<td class="main"><b><?php echo TEXT_RETURN_NO; ?></b></td>
				<td class="main"><?php echo tep_db_input($rID); ?></td>
			  </tr>
			  <!-- add date/time // -->
			  <tr>
				<td class="main"><b><?php echo TEXT_DATE_TIME; ?></b></td>
				<td class="main"><?php echo tep_datetime_short($return->info['date_added']); ?></td>
			  </tr>
			  <tr>
				<td class="main"><b><?php echo TEXT_RMA_VALUE; ?></b></td>
				<td class="main"><?php echo $return->info['rma_value']; ?></td>
			  </tr>
            </table>

       </fieldset>
        </td>
        <td width="33%" valign="top">
          <fieldset style="border: 0; height: 100%;">
            <legend style="margin-left: -20px; font-weight: bold;"><?php echo ENTRY_RETURNS_STATUS; ?></legend>

            <p><?php echo $return->info['returns_status_name'] . '<br />' . (empty($return->info['last_modified']) ? tep_datetime_short($return->info['date_added']) : tep_datetime_short($return->info['last_modified'])); ?></p>
          </fieldset>
        </td>
        <td width="33%" valign="top">
          <fieldset style="border: 0; height: 100%;">
            <legend style="margin-left: -20px; font-weight: bold;"><?php echo ENTRY_REFUND_DETAILS; ?></legend>
			<table border="0" cellspacing="0" cellpadding="0">
              <tr>
			    <td><?php echo ENTRY_RETURNS_CUSTOMER_PREF_REFUND; ?>&nbsp;&nbsp;</td>
				<td><?php echo $return->info['refund_method_name']; ?></td>
			  </tr>
			  <?php 
			    if ($return->info['refund_payment_name'] != '') {
				?>
			  <tr>
			    <td class="main"><?php echo ENTRY_ACTUAL_REFUND; ?></td>
				<td class="main"><?php echo $return->info['refund_payment_name']; ?></td>
			  <tr>
			  <?php
				}
			  ?>

			</table>
          </fieldset>
        </td>
      </tr>
    </table>
  </div>

  <div id="section_products_content" style="padding: 10px;">
    <table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr class="dataTableHeadingRow">
        <td class="dataTableHeadingContent" colspan="2"><?php echo TABLE_HEADING_PRODUCTS; ?></td>
        <td class="dataTableHeadingContent"><?php echo TABLE_HEADING_PRODUCTS_MODEL; ?></td>
        <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_TAX; ?></td>
        <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_PRICE_EXCLUDING_TAX; ?></td>
        <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_PRICE_INCLUDING_TAX; ?></td>
        <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_TOTAL_EXCLUDING_TAX; ?></td>
        <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_TOTAL_INCLUDING_TAX; ?></td>
      </tr>
<?php
    
      echo '      <tr class="dataTableRow">' . "\n" .
           '        <td class="dataTableContent" valign="top" align="right">' . $return->products['qty'] . '&nbsp;x</td>' . "\n" .
           '        <td class="dataTableContent" valign="top">' . $return->products['name'];

      if (isset($return->products['attributes']) && (sizeof($return->products['attributes']) > 0)) {
        for ($j = 0, $k = sizeof($return->products['attributes']); $j < $k; $j++) {
          echo '<br /><nobr><small>&nbsp;<i> - ' . $return->products['attributes'][$j]['option'] . ': ' . $return->products['attributes'][$j]['value'];
          if ($return->products['attributes'][$j]['price'] != '0') echo ' (' . $return->products['attributes'][$j]['prefix'] . $currencies->format($return->products['attributes'][$j]['price'] * $return->products['qty'], true, $return->info['currency'], $return->info['currency_value']) . ')';
          echo '</i></small></nobr>';
        }
      }

      echo '        </td>' . "\n" .
           '        <td class="dataTableContent" valign="top">' . $return->products['model'] . '</td>' . "\n" .
           '        <td class="dataTableContent" align="right" valign="top">' . tep_display_tax_value($return->products['tax']) . '%</td>' . "\n" .
           '        <td class="dataTableContent" align="right" valign="top"><strong>' . $currencies->format($return->products['final_price'], true, $return->info['currency'], $return->info['currency_value']) . '</strong></td>' . "\n" .
           '        <td class="dataTableContent" align="right" valign="top"><strong>' . $currencies->format(tep_add_tax($return->products['final_price'], $return->products['tax'], true), true, $return->info['currency'], $return->info['currency_value']) . '</strong></td>' . "\n" .
           '        <td class="dataTableContent" align="right" valign="top"><strong>' . $currencies->format($return->products['final_price'] * $return->products['qty'], true, $return->info['currency'], $return->info['currency_value']) . '</strong></td>' . "\n" .
           '        <td class="dataTableContent" align="right" valign="top"><strong>' . $currencies->format(tep_add_tax($return->products['final_price'], $return->products['tax'], true) * $return->products['qty'], true, $return->info['currency'], $return->info['currency_value']) . '</strong></td>' . "\n";
      echo '      </tr>' . "\n";

?>
      <tr>
        <td align="right" colspan="8"><table border="0" cellspacing="0" cellpadding="2">
<?php

		if ($return->info['deductions'] != '0.0000') {
			echo '          <tr>' . "\n" .
				 '            <td align="right" class="smallText">' . TEXT_TOTAL_DEDUCTIONS . '</td>' . "\n" .
				 '            <td align="right" class="smallText">' . $currencies->format($return->info['deductions'], true, $return->info['currency'], $return->info['currency_value']) . '</td>' . "\n" .
				 '          </tr>' . "\n";				
		  }
		  
		if ($return->info['finalised'] == '1') {
			echo '          <tr>' . "\n" .
				 '            <td align="right" class="smallText">' . TEXT_TOTAL_REFUNDED . '</td>' . "\n" .
				 '            <td align="right" class="smallText"><strong>' . $currencies->format($return->info['refund_amount'], true, $return->info['currency'], $return->info['currency_value']) . '</strong></td>' . "\n" .
				 '          </tr>' . "\n";

	   } else {
			
			echo '          <tr>' . "\n" .
				 '            <td align="right" class="smallText">' . TEXT_TOTAL_TO_BE_REFUNDED . '</td>' . "\n" .
				 '            <td align="right" class="smallText"><strong>' . $currencies->format($return->info['refund_amount'], true, $return->info['currency'], $return->info['currency_value']) . '</strong></td>' . "\n" .
				 '          </tr>' . "\n";				
				  
		  }

?>
        </table></td>
      </tr>
    </table>
  </div>

  <div id="section_status_history_content">
 <script type="text/javascript" src="ext/js/textrange/jquery-textrange.js"></script> 
<script>
</script>
    <?php echo tep_draw_form('status', 'returns.php', tep_get_all_get_params(array('action')) . 'action=update_order'); ?>

    <table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr>
        <td width="200"><strong><?php echo ENTRY_RETURNS_STATUS; ?></strong></td>
        <td><?php echo tep_draw_pull_down_menu('status', $returns_statuses, $return->info['returns_status']); ?></td>
      </tr>
	  <tr>
        <td><strong><?php echo ENTRY_RETURNS_REASON; ?></strong></td>
        <td><?php echo tep_draw_pull_down_menu('reason', $reasons, $return->info['return_reason_id']); ?></td>
      </tr>
	  <tr>
        <td><strong><?php echo ENTRY_RETURNS_CUSTOMER_PREF_REFUND; ?></strong></td>
        <td>&nbsp;<?php echo $pref_refund_name['refund_method_name']; ?></td>
      </tr>
	  <tr>
        <td><strong><?php echo ENTRY_RETURNS_PAYMENT_REFERENCE; ?></strong></td>
        <td><? echo tep_draw_input_field('refund_reference', $return->info['payment_reference']); ?></td>
      </tr>
	  <?php
		  if (RETURNS_SHOW_SERIAL_NUMBER == '1') {
		  ?>
      <tr>
			<td><strong><?php echo TEXT_RETURNS_SERIAL_NUMBER; ?></strong></td>
			<td><?php echo tep_draw_input_field('products_serial_number', $return->products['serial_number']); ?></td>
      </tr>
      <?php
			}
      ?>
      <tr>
        <td><strong><?php echo ENTRY_ADD_COMMENT; ?></strong></td>
        <td><?php echo tep_draw_textarea_field('comments', 'soft', '60', '6', null, 'style="width: 100%;" id="textarea" '); ?></td>
      </tr>
	  <tr>
	    <td><strong><?php echo TEXT_BUTTONS_ADD; ?></strong><td>
		
<script>
$(document).ready(function() {
	
	$('#approved-replace').click(function() {
		$('#textarea').val('<?php echo preg_replace('/<br\s?\/?>/i', '\n', TEXT_COMMENT_RETURN_APPROVED); ?>');
	});
	
	$('#refunded-replace').click(function() {
		$('#textarea').val('<?php echo preg_replace('/<br\s?\/?>/i', '\n', TEXT_COMMENT_RETURN_REFUNDED); ?>');
	});
	
	$('#credit-replace').click(function() {
		$('#textarea').val('<?php echo preg_replace('/<br\s?\/?>/i', '\n', TEXT_COMMENT_RETURN_CREDITED); ?>');
	});
	
	$('#rejected-replace').click(function() {
		$('#textarea').val('<?php echo preg_replace('/<br\s?\/?>/i', '\n', TEXT_COMMENT_RETURN_REJECTED); ?>');
	});
	
	$('#restock-applied-replace').click(function() {
		$('#textarea').val($('#textarea').val() + '<?php echo sprintf(preg_replace('/<br\s?\/?>/i', '\n', TEXT_COMMENT_RESTOCK_APPLIED), $restock_percentage . '%'); ?>');
	});
});
</script>
<input type="button" id="approved-replace" type="button" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-icon-primary ui-priority-primary" role="button" aria-disabled="false" value="<?php echo TEXT_BUTTON_RETURN_APPROVED; ?>">
<input type="button" id="rejected-replace" type="button" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-icon-primary ui-priority-primary" role="button" aria-disabled="false" value="<?php echo TEXT_BUTTON_RETURN_REJECTED; ?>">
<input type="button" id="credit-replace" type="button" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-icon-primary ui-priority-primary" role="button" aria-disabled="false" value="<?php echo TEXT_BUTTON_RETURN_CREDITED; ?>">
<input type="button" id="refunded-replace" type="button" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-icon-primary ui-priority-primary" role="button" aria-disabled="false" value="<?php echo TEXT_BUTTON_RETURN_REFUNDED; ?>">
<input type="button" id="restock-applied-replace" type="button" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-icon-primary ui-priority-primary" role="button" aria-disabled="false" value="<?php echo TEXT_BUTTON_RETURN_RESTOCK_APPLIED; ?>">
	  </tr>
      <tr>
        <td><strong><?php echo ENTRY_NOTIFY_CUSTOMER; ?></strong></td>
        <td><?php echo tep_draw_checkbox_field('notify', '', true); ?></td>
      </tr>
        <td><strong><?php echo ENTRY_NOTIFY_COMMENTS; ?></strong></td>
        <td><?php echo tep_draw_checkbox_field('notify_comments', '', true); ?></td>
      </tr>	  
	  <tr>
	    <td><strong><?php echo ENTRY_REFUND; ?></strong></td>
		<td>
		  <table>
			  <tr>
			  <?php
			  
			  if ($return->info['finalised'] == 1) {

				echo '<td>' . ENTRY_REFUND_DETAILS . '</td>' . "\n" . 
					 '<td>' . tep_draw_input_field('refunded_method', $return->info['refund_payment_name'], 'id="refund_method" readonly="readonly"') . '</td>' . "\n" . 
					 '<td>' . ENTRY_PAYMENT_AMOUNT . '</td>' . "\n" . 
					 '<td>' . tep_draw_input_field('refunded_amount', $currencies->format($return->info['refund_amount'], true, $return->info['currency'], $return->info['currency_value']), 'id="refund_amount"  readonly="readonly"') . tep_draw_hidden_field('refund_amount', $refund_amount['refund_payment_value']) . '</td>' . "\n";
				
				if ($return->info['deductions'] != '0.0000') {
				  echo '<td>' . sprintf(TEXT_DEDUCTION_AMOUNT, $currencies->format($return->info['refund_amount'], true, $return->info['currency'], $return->info['currency_value']), $currencies->format($return->info['deductions'], true, $return->info['currency'], $return->info['currency_value']), tep_round($refund_amount['refund_payment_deductions'], 2)) . '</td>' . "\n";				
				} 
				
				echo '<td>' . TEXT_CANNOT_BE_CHANGED . '</td>' . "\n";

			  } else {
				  
				  if ($return->info['deductions'] != '0.0000') {
					 $refund_value = tep_round(tep_add_tax($return->products['final_price'] * $return->products['qty'], $return->products['tax'], true), 2);
				  } else {
					 $refund_value = tep_round($return->info['refund_amount'], 2);
				  }

				echo '<td>' . ENTRY_REFUND_DETAILS . '</td>' . "\n" . 
					 '<td>' . tep_draw_pull_down_menu('refund_method', $refunds_methods, $return->info['customer_method']) . '</td>' . "\n" . 
					 '<td>' . ENTRY_PAYMENT_AMOUNT . '</td>' . "\n" . 
					 '<td>' . tep_draw_input_field('refund_amount', tep_round($return->info['refund_amount'], 2), 'id="refund_amount"') . '</td>' . "\n";

			   $restock_deducted = tep_round($refund_value * (100 - DEFAULT_RESTOCK_VALUE) / 100, 2);
			     if ($return->info['deductions'] == '0.0000') {
			  ?>
			    <script>
				  $(document).ready(function() {
				  
				    $('#refund-replace').click(function() {
				    $('#refund_amount').val('<?php echo $restock_deducted; ?>');
				    $('#textarea').val($('#textarea').val() + '<?php echo sprintf(preg_replace('/<br\s?\/?>/i', '\n', TEXT_COMMENT_RESTOCK_APPLIED), DEFAULT_RESTOCK_VALUE . '%'); ?>');				  
				    });
			
				    $('#full-refund').click(function() {
				    $('#refund_amount').val('<?php echo tep_add_tax($return->products['final_price'] * $return->products['qty'], $return->products['tax'], true); ?>');
				    });
				  });
			    </script>
					  
			    <td><input type="button" id="refund-replace" name="refund-replace" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-icon-primary ui-priority-primary" role="button" aria-disabled="false" value="<?php echo sprintf(BUTTON_TEXT_RESTOCK_TOTAL, DEFAULT_RESTOCK_VALUE); ?>"> <input type="button" id="full-refund" name="full-refund" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-icon-primary ui-priority-primary" role="button" aria-disabled="false" value="<?php echo BUTTON_TEXT_RESTOCK_FULL_TOTAL; ?>"></td>
			  
			  <?php
			     } else {
				   echo '<td>' . sprintf(TEXT_DEDUCTION_AMOUNT, $currencies->format($refund_value, true, $return->info['currency'], $return->info['currency_value']), $currencies->format($return->info['deductions'], true, $return->info['currency'], $return->info['currency_value']), tep_round($refund_amount['refund_payment_deductions'], 2)) . '</td>' . "\n";
			       echo '<td>' . TEXT_CAN_BE_CHANGED . '</td>' . "\n";
				 }
			  }
			  ?>
			</tr>
		  </table>
		</td>
	  </tr>
	  <tr>
        <td><strong><?php echo TEXT_FINALISE_RETURN; ?></strong></td>
        <td>
		<?php 
		if ($return->info['finalised'] != '1') { 
		  echo tep_draw_checkbox_field('finalised', '1', false);
		} else {
		  echo sprintf(TEXT_ORDER_COMPLETED, tep_datetime_short($return->info['refund_date']));
		}
		?>
		</td>
      </tr>
	  <tr>
        <td><strong><?php echo TEXT_BACK_TO_STOCK; ?></strong></td>
        <td>
		<?php
		//$returns_restock_query = tep_db_query("SELECT products_id, products_returned, products_quantity FROM returns_products_data where returns_id = '" . $rID . "'");
        //returns_restock = tep_db_fetch_array($returns_restock_query);
		
		if ($return->products['products_returned'] != '1') {		
		  echo tep_draw_checkbox_field('restock_products', '', false); 
		
		} else {
		  echo TEXT_PRODUCT_ALREADY_RETURNED;
		}
		?>
		</td>
      </tr>
      <tr>
        <td colspan="2" align="center"><?php echo tep_draw_button(IMAGE_UPDATE, 'disk', null, 'primary'); ?></td>
      </tr>
    </table>

    </form>

    <br />

    <table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr class="dataTableHeadingRow">
        <td class="dataTableHeadingContent" align="center"><strong><?php echo TABLE_HEADING_DATE_ADDED; ?></strong></td>
        <td class="dataTableHeadingContent" align="center"><strong><?php echo TABLE_HEADING_STATUS; ?></strong></td>
        <td class="dataTableHeadingContent" align="center"><strong><?php echo TABLE_HEADING_COMMENTS; ?></strong></td>
        <td class="dataTableHeadingContent" align="right"><strong><?php echo TABLE_HEADING_CUSTOMER_NOTIFIED; ?></strong></td>
      </tr>

<?php
    $returns_history_query = tep_db_query("select returns_status_id, date_added, customer_notified, comments from returns_status_history where returns_id = '" . tep_db_input($rID) . "' order by date_added desc");
    if (tep_db_num_rows($returns_history_query)) {
      while ($returns_history = tep_db_fetch_array($returns_history_query)) {
        echo '      <tr class="dataTableRow">' . "\n" .
             '        <td class="dataTableContent" valign="top">' . tep_datetime_short($returns_history['date_added']) . '</td>' . "\n" .
             '        <td class="dataTableContent" valign="top">' . $returns_status_array[$returns_history['returns_status_id']] . '</td>' . "\n" .
             '        <td class="dataTableContent" valign="top">' . nl2br(tep_db_output($returns_history['comments'])) . '&nbsp;</td>' . "\n" .
             '        <td class="dataTableContent" valign="top" align="right">';

        if ($returns_history['customer_notified'] == '1') {
          echo tep_image('images/icons/tick.gif', ICON_TICK);
        } else {
          echo tep_image('images/icons/cross.gif', ICON_CROSS);
        }

        echo '        </td>' . "\n" .
             '      </tr>' . "\n";
      }
    } else {
        echo '      <tr class="dataTableRow">' . "\n" .
             '        <td class="dataTableContent" colspan="5">' . TEXT_NO_RETURN_HISTORY . '</td>' . "\n" .
             '      </tr>' . "\n";
    }
?>

    </table>
  </div>

<?php
    echo $OSCOM_Hooks->call('returns', 'returnsTab');
?>

</div>

<script>
$(function() {
  $('#returnTabs').tabs();
});
</script>

<?php
  } else {
?>
    <table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr>
        <td width="100%"><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td class="pageHeading"><?php echo HEADING_TITLE; ?></td>
            <td class="pageHeading" align="right"><?php echo tep_draw_separator('pixel_trans.gif', 1, HEADING_IMAGE_HEIGHT); ?></td>
            <td align="right"><table border="0" width="100%" cellspacing="0" cellpadding="0">
              <tr><?php echo tep_draw_form('returns', 'returns.php', '', 'get'); ?>
                <td class="smallText" align="right"><?php echo HEADING_TITLE_SEARCH . ' ' . tep_draw_input_field('search'); ?></td>
              <?php echo tep_hide_session_id(); ?></form></tr>
              <tr><?php echo tep_draw_form('status', 'returns.php', '', 'get'); ?>
                <td class="smallText" align="right"><?php echo HEADING_TITLE_STATUS . ' ' . tep_draw_pull_down_menu('status', array_merge(array(array('id' => '', 'text' => TEXT_ALL_RETURNS)), $returns_statuses), '', 'onchange="this.form.submit();"'); ?></td>
              <?php echo tep_hide_session_id(); ?></form></tr>
            </table></td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="2">
              <tr class="dataTableHeadingRow">
                <td class="dataTableHeadingContent"><?php echo TABLE_HEADING_CUSTOMERS; ?></td>
                <td class="dataTableHeadingContent" align="center"><?php echo TABLE_HEADING_RMA_NUMBER; ?></td>
                <td class="dataTableHeadingContent" align="center"><?php echo TABLE_HEADING_DATE_PURCHASED; ?></td>
                <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_REASON; ?></td>
                <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_STATUS; ?></td>
                <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_ACTION; ?>&nbsp;</td>
              </tr>
<?php
    $search = '';
    if (isset($_GET['search']) && tep_not_null($_GET['search'])) {
      $keywords = tep_db_input(tep_db_prepare_input($_GET['search']));
      $search = "(rp.customers_name like '%" . $keywords . "%' or rp.orders_id like '%" . $keywords . "%' or rp.rma_value like '%" . $keywords . "%' or rp.returns_id like '%" . $keywords . "%') and" ;
    }

    if (isset($_GET['cID'])) {
      $cID = tep_db_prepare_input($_GET['cID']);
      $returns_query_raw = "select rp.returns_id, rp.rma_value, rp.return_reason_id, rp.orders_id, rp.customers_name, rp.customers_id, rp.date_added, rp.last_modified, rs.returns_status_name, s.return_reason_name from returned_products rp, returns_status rs, return_reasons s where " . $search . " rp.return_reason_id = s.return_reason_id and rp.customers_id = '" . (int)$cID . "' and rp.returns_status = rs.returns_status_id and rs.language_id = '" . (int)$languages_id . "' and s.language_id = '" . (int)$languages_id . "' order by returns_id DESC";
    } elseif (isset($_GET['status']) && is_numeric($_GET['status']) && ($_GET['status'] > 0)) {
      $status = tep_db_prepare_input($_GET['status']);
      $returns_query_raw = "select rp.returns_id, rp.rma_value, rp.return_reason_id, rp.orders_id, rp.customers_name, rp.date_added, rp.last_modified, rs.returns_status_name, s.return_reason_name from returned_products rp, returns_status rs, return_reasons s where " . $search . " rp.return_reason_id = s.return_reason_id and rp.returns_status = rs.returns_status_id and rs.language_id = '" . (int)$languages_id . "' and s.language_id = '" . (int)$languages_id . "' and rs.returns_status_id = '" . (int)$status . "' order by rp.returns_id DESC";
    } else {
      $returns_query_raw = "select rp.returns_id, rp.rma_value, rp.return_reason_id, rp.orders_id, o.customers_name, rp.date_added, rp.last_modified, rs.returns_status_name, s.return_reason_name from returned_products rp, orders o, returns_status rs, return_reasons s where " . $search . " rp.return_reason_id = s.return_reason_id and rp.orders_id = o.orders_id and rp.returns_status = rs.returns_status_id and rs.language_id = '" . (int)$languages_id . "' and s.language_id = '" . (int)$languages_id . "' order by rp.returns_id DESC";
    }
    $returns_split = new splitPageResults($_GET['page'], MAX_DISPLAY_SEARCH_RESULTS, $returns_query_raw, $returns_query_numrows);
    $returns_query = tep_db_query($returns_query_raw);
    while ($returns = tep_db_fetch_array($returns_query)) {
    if ((!isset($_GET['rID']) || (isset($_GET['rID']) && ($_GET['rID'] == $returns['returns_id']))) && !isset($rInfo)) {
        $rInfo = new objectInfo($returns);
      }

      if (isset($rInfo) && is_object($rInfo) && ($returns['returns_id'] == $rInfo->returns_id)) {
        echo '              <tr id="defaultSelected" class="dataTableRowSelected" onmouseover="rowOverEffect(this)" onmouseout="rowOutEffect(this)" onclick="document.location.href=\'' . tep_href_link('returns.php', 'rID=' . $rInfo->returns_id . '&action=edit&oID=' . $rInfo->orders_id) . '\'">' . "\n";
      } else {
        echo '              <tr class="dataTableRow" onmouseover="rowOverEffect(this)" onmouseout="rowOutEffect(this)" onclick="document.location.href=\'' . tep_href_link('returns.php', 'rID=' . $returns['returns_id'] . '&oID=' . $returns['orders_id']) . '\'">' . "\n";
      }
?>
                <td class="dataTableContent"><?php echo '<a href="' . tep_href_link('returns.php', 'rID=' . $returns['returns_id'] . '&action=edit&oID=' . $returns['orders_id']) . '">' . tep_image('images/icons/preview.gif', ICON_PREVIEW) . '</a>&nbsp;' . $returns['customers_name']; ?></td>
                <td class="dataTableContent" align="center"><?php echo $returns['rma_value']; ?></td>
                <td class="dataTableContent" align="center"><?php echo tep_datetime_short($returns['date_added']); ?></td>				
                <td class="dataTableContent" align="right"><?php echo $returns['return_reason_name']; ?></td>
                <td class="dataTableContent" align="right"><?php echo $returns['returns_status_name']; ?></td>
                <td class="dataTableContent" align="right"><?php if (isset($rInfo) && is_object($rInfo) && ($returns['returns_id'] == $rInfo->returns_id)) { echo tep_image('images/icon_arrow_right.gif', ''); } else { echo '<a href="' . tep_href_link('returns.php', 'rID=' . $returns['returns_id']) . '">' . tep_image('images/icon_info.gif', IMAGE_ICON_INFO) . '</a>'; } ?>&nbsp;</td>
              </tr>
<?php
    }
?>
              <tr>
                <td colspan="5"><table border="0" width="100%" cellspacing="0" cellpadding="2">
                  <tr>
                    <td class="smallText" valign="top"><?php echo $returns_split->display_count($returns_query_numrows, MAX_DISPLAY_SEARCH_RESULTS, $_GET['page'], TEXT_DISPLAY_NUMBER_OF_RETURNS); ?></td>
                    <td class="smallText" align="right"><?php echo $returns_split->display_links($returns_query_numrows, MAX_DISPLAY_SEARCH_RESULTS, MAX_DISPLAY_PAGE_LINKS, $_GET['page'], tep_get_all_get_params(array('page', 'rID', 'action'))); ?></td>
                  </tr>
                </table></td>
              </tr>
            </table></td>
<?php
  $heading = array();
  $contents = array();

  switch ($action) {
    case 'delete':
      $heading[] = array('text' => '<strong>' . TEXT_INFO_HEADING_DELETE_RETURN . '</strong>');

      $contents = array('form' => tep_draw_form('returns', 'returns.php', tep_get_all_get_params(array('rID', 'action')) . 'rID=' . $rInfo->returns_id . '&action=deleteconfirm'));
      $contents[] = array('text' => TEXT_INFO_DELETE_INTRO . '<br /><br /><strong>' . $cInfo->customers_firstname . ' ' . $cInfo->customers_lastname . '</strong>');
      $contents[] = array('align' => 'center', 'text' => '<br />' . tep_draw_button(IMAGE_DELETE, 'trash', null, 'primary') . tep_draw_button(IMAGE_CANCEL, 'close', tep_href_link('returns.php', tep_get_all_get_params(array('rID', 'action')) . 'rID=' . $rInfo->returns_id)));
      break;
    default:
      if (isset($rInfo) && is_object($rInfo)) {
        $heading[] = array('text' => '<strong>[' . $rInfo->returns_id . ']&nbsp;&nbsp;' . tep_datetime_short($rInfo->date_added) . '</strong>');

        $contents[] = array('align' => 'center', 'text' => tep_draw_button(IMAGE_EDIT, 'document', tep_href_link('returns.php', tep_get_all_get_params(array('rID', 'action')) . 'rID=' . $rInfo->returns_id . '&action=edit&oID=' . $rInfo->orders_id)) . tep_draw_button(IMAGE_DELETE, 'trash', tep_href_link('returns.php', tep_get_all_get_params(array('rID', 'action')) . 'rID=' . $rInfo->returns_id . '&action=delete')));
		$contents[] = array('text' => '<br />' . TEXT_INFO_RMA_VALUE . ' '  . $rInfo->rma_value);
        $contents[] = array('text' => '<br />' . TEXT_DATE_RETURN_CREATED . ' ' . tep_date_short($rInfo->date_added));
        if (tep_not_null($rInfo->last_modified)) $contents[] = array('text' => TEXT_DATE_RETURN_LAST_MODIFIED . ' ' . tep_date_short($rInfo->last_modified));
        $return_complete_query = tep_db_query("SELECT returns_date_finished FROM returned_products where returns_id = '" . $rInfo->returns_id . "'");
		$return_complete = tep_db_fetch_array($return_complete_query);
		  if ($return_complete['returns_date_finished'] != '0000-00-00 00:00:00') {
		$contents[] = array('text' => '<br />' . TEXT_INFO_DATE_COMPLETED . ' '  . tep_date_short($return_complete['returns_date_finished']));
		}
      }
      break;
  }

  if ( (tep_not_null($heading)) && (tep_not_null($contents)) ) {
    echo '            <td width="25%" valign="top">' . "\n";

    $box = new box;
    echo $box->infoBox($heading, $contents);

    echo '            </td>' . "\n";
  }
?>
          </tr>
        </table></td>
      </tr>
    </table>
<?php
  }

  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>
