<?php
/**
  * RMA Return System for osCommerce Online Merchant
  *
  * Author: frankl
  *
  * Portions @copyright (c) 2017 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */

  if ( !class_exists('OSCOM_PayPal') ) {
    include(DIR_FS_CATALOG . 'includes/apps/paypal/OSCOM_PayPal.php');
  }

  class paypal_hook_admin_returns_action {
    function __construct() {
      global $OSCOM_PayPal;

      if ( !isset($OSCOM_PayPal) || !is_object($OSCOM_PayPal) || (get_class($OSCOM_PayPal) != 'OSCOM_PayPal') ) {
        $OSCOM_PayPal = new OSCOM_PayPal();
      }

      $this->_app = $OSCOM_PayPal;

      $this->_app->loadLanguageFile('hooks/admin/returns/action.php');
    }

    function execute() {
		global $return;
      if ( isset($_GET['tabaction']) ) {
		
        $ppstatus_query = tep_db_query("select comments from orders_status_history where orders_id = '" . (int)$_GET['oID'] . "' and orders_status_id = '" . (int)OSCOM_APP_PAYPAL_TRANSACTIONS_ORDER_STATUS_ID . "' and comments like '%Transaction ID:%' order by date_added limit 1");
        if ( tep_db_num_rows($ppstatus_query) ) {
		//tep_redirect(tep_href_link('returns.php', 'oID=' . $oID . '&rID=' . $rID . '&action=edit&id=' . $products_id));
         $ppstatus = tep_db_fetch_array($ppstatus_query);

          $pp = array();

          foreach ( explode("\n", $ppstatus['comments']) as $s ) {
            if ( !empty($s) && (strpos($s, ':') !== false) ) {
              $entry = explode(':', $s, 2);

              $pp[trim($entry[0])] = trim($entry[1]);
			  $pp[trim($entry[1])] = trim($entry[2]);
            }
          }

          if ( isset($pp['Transaction ID']) ) {

            $o_query = tep_db_query("select o.orders_id, o.payment_method, o.currency, o.currency_value, ot.value as total from orders o, orders_total ot where o.orders_id = '" . (int)$_GET['oID'] . "' and o.orders_id = ot.orders_id and ot.class = 'ot_total'");
            $o = tep_db_fetch_array($o_query);
			
			$r_query = tep_db_query("select r.returns_id, rp.customer_method, rp.refund_payment_value as total from returned_products r, refund_payments rp where r.returns_id = '" . (int)$_GET['rID'] . "' and r.returns_id = rp.returns_id");
            $r = tep_db_fetch_array($r_query);

            switch ( $_GET['tabaction'] ) {

              case 'refundTransaction':
			  
                $this->refundTransaction($pp, $o, $r);
                break;
            }

            tep_redirect(tep_href_link('returns.php', 'page=' . $_GET['page'] . '&oID=' . $_GET['oID'] . '&rID=' . $_GET['rID'] . '&action=edit#section_status_history_content'));
          }
        }
      }
    }
	
	
	function refundTransaction($comments, $order, $returns) {
      global $messageStack, $_POST, $return;

      if ( isset($_POST['ppRefund']) ) {
		  
		  //$messageStack->add_session($tids[$comments['Transaction ID']]['Amount'], 'warning');
		  
        $tids = array();

        $ppr_query = tep_db_query("select comments from orders_status_history where orders_id = '" . (int)$order['orders_id'] . "' and orders_status_id = '" . (int)OSCOM_APP_PAYPAL_TRANSACTIONS_ORDER_STATUS_ID . "' and comments like 'PayPal App: %' order by date_added desc");
        if ( tep_db_num_rows($ppr_query) ) {

          while ( $ppr = tep_db_fetch_array($ppr_query) ) {
			preg_match('/^PayPal App\: PartialRefund \(([0-9\.]+)\).*Transaction ID\: ([A-Za-z0-9]+)/s', $ppr['comments'], $ppr_matches);
				$tids[$ppr_matches[1]]['Balance'] += $ppr_matches[1];
		  }
        }
		
		$tids[$comments['Transaction ID']]['Amount'] = $this->_app->formatCurrencyRaw($returns['total'], $order['currency'], $order['currency_value']);

        $rids = array();

        foreach ( $_POST['ppRefund'] as $id ) {
          if ( isset($tids[$id]) ) {
            $rids[] = $id;
          }
        }

        foreach ( $rids as $id ) {
          $pass = false;

          if ( !isset($comments['Gateway']) ) {
			$response = $this->_app->getApiResult('APP', 'RefundTransaction', array('TRANSACTIONID' => $id, 'REFUNDTYPE' => 'Partial', 'AMT' => $tids[$comments['Transaction ID']]['Amount']), (strpos($order['payment_method'], 'Sandbox') === false) ? 'live' : 'sandbox');

            if ( in_array($response['ACK'], array('Success', 'SuccessWithWarning')) ) {
              $transaction_id = $response['REFUNDTRANSACTIONID'];

              $pass = true;
			  
            }
          } elseif ( $comments['Gateway'] == 'Payflow' ) {
            $response = $this->_app->getApiResult('APP', 'PayflowRefund', array('ORIGID' => $id, 'AMT' => $tids[$comments['Transaction ID']]['Amount']), (strpos($order['payment_method'], 'Sandbox') === false) ? 'live' : 'sandbox');

            if ( isset($response['RESULT']) && ($response['RESULT'] == '0') ) {
              $transaction_id = $response['PNREF'];

              $pass = true;
            }
          }

          if ( $pass === true ) {
            $order_comment = 'PayPal App: PartialRefund (' . $tids[$id]['Amount'] . ')' . "\n" .
							 'Transaction ID: ' . tep_output_string_protected($transaction_id) . "\n" .
							 'Parent ID: ' . tep_output_string_protected($id);

            $order_comment_data_array = array('orders_id' => (int)$order['orders_id'],
                                    'orders_status_id' => OSCOM_APP_PAYPAL_TRANSACTIONS_ORDER_STATUS_ID,
                                    'date_added' => 'now()',
                                    'customer_notified' => '0',
                                    'comments' => $order_comment);

            tep_db_perform('orders_status_history', $order_comment_data_array);
			
			$result = 'PayPal App: Refund (' . $tids[$id]['Amount'] . ')' . "\n" .
                      'Transaction ID: ' . tep_output_string_protected($transaction_id) . "\n" .
                      'Parent ID: ' . tep_output_string_protected($id) . "\n" .
					  'Extra Comment: ' . $this->_app->getDef('ms_success_refundTransactionReturn');

            $sql_data_array = array('orders_id' => (int)$order['orders_id'],
                                    'orders_status_id' => OSCOM_APP_PAYPAL_TRANSACTIONS_ORDER_STATUS_ID,
                                    'date_added' => 'now()',
                                    'customer_notified' => '0',
                                    'comments' => $result);

            tep_db_perform('orders_status_history', $sql_data_array);
			
			$return_comment = 'PayPal: Refund (' . $tids[$id]['Amount'] . ')' . "\n" .
							  'Transaction ID: ' . tep_output_string_protected($transaction_id) . "\n" .
							  'Parent ID: ' . tep_output_string_protected($id);

            $returns_data_array = array('returns_id' => (int)$returns['returns_id'],
										'returns_status_id' => RETURNS_PAYPAL_TRANSACTIONS_ORDER_STATUS_ID,
										'date_added' => 'now()',
										'customer_notified' => '0',
										'comments' => $return_comment);

            tep_db_perform('returns_status_history', $returns_data_array);
			
			$returns_closed_comment = 'Your return has now been closed' . "\n" .
									  'PayPal: Refund (' . $tids[$id]['Amount'] . ')' . "\n";

			
			$returns_closed_array = array('returns_id' => (int)$returns['returns_id'],
										  'returns_status_id' => RETURNS_CLOSED_TRANSACTIONS_ORDER_STATUS_ID,
										  'date_added' => 'now()',
										  'customer_notified' => '1',
										  'comments' => $returns_closed_comment);

            tep_db_perform('returns_status_history', $returns_closed_array);
			
			
			tep_db_query("update refund_payments set refund_payment_name = 'Paypal', refund_payment_finalised = 1 where returns_id = '" . (int)$returns['returns_id'] . "'");
			tep_db_query("update returned_products set returns_status = '" . RETURNS_CLOSED_TRANSACTIONS_ORDER_STATUS_ID . "' where returns_id = '" . (int)$returns['returns_id'] . "'");

            $messageStack->add_session($this->_app->getDef('ms_success_refundTransaction', array('refund_amount' => $tids[$id]['Amount'])), 'success');
          } else {
            $messageStack->add_session($this->_app->getDef('ms_error_refundTransaction', array('refund_amount' => $tids[$id]['Amount'] . ' ' . $returns['total'])), 'error');
          }
        }
      }
    }

  }
?>
