<?php
/**
  * RMA Return System for osCommerce Online Merchant
  *
  * Author: frankl
  *
  * Portions @copyright (c) 2017 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */

  if ( !class_exists('OSCOM_PayPal') ) {
    include(DIR_FS_CATALOG . 'includes/apps/paypal/OSCOM_PayPal.php');
  }

  class paypal_hook_admin_returns_tab {
    function __construct() {
      global $OSCOM_PayPal;

      if ( !isset($OSCOM_PayPal) || !is_object($OSCOM_PayPal) || (get_class($OSCOM_PayPal) != 'OSCOM_PayPal') ) {
        $OSCOM_PayPal = new OSCOM_PayPal();
      }

      $this->_app = $OSCOM_PayPal;

      $this->_app->loadLanguageFile('hooks/admin/returns/tab.php');
    }

    function execute() {
      global $oID, $rID, $return;

      $output = '';

      $status = array();

	  $ppstatus_query = tep_db_query("select comments from orders_status_history where orders_id = '" . (int)$return->info['orders_id'] . "' and orders_status_id = '" . (int)OSCOM_APP_PAYPAL_TRANSACTIONS_ORDER_STATUS_ID . "' and comments like 'Transaction ID:%' order by date_added desc limit 1");
	  
      if ( tep_db_num_rows($ppstatus_query) ) {
        $ppstatus = tep_db_fetch_array($ppstatus_query);

        foreach ( explode("\n", $ppstatus['comments']) as $s ) {
          if ( !empty($s) && (strpos($s, ':') !== false) ) {
            $entry = explode(':', $s, 2);

            $status[trim($entry[0])] = trim($entry[1]);
          }
        }

        if ( isset($status['Transaction ID']) ) {
          $order_query = tep_db_query("select o.orders_id, o.payment_method, o.currency, o.currency_value, ot.value as total from orders o, orders_total ot where o.orders_id = '" . (int)$return->info['orders_id'] . "' and o.orders_id = ot.orders_id and ot.class = 'ot_total'");
          $order = tep_db_fetch_array($order_query);

          $pp_server = (strpos(strtolower($order['payment_method']), 'sandbox') !== false) ? 'sandbox' : 'live';

          $info_button = $this->_app->drawButton($this->_app->getDef('button_details'), tep_href_link('orders.php', 'page=' . $_GET['page'] . '&oID=' . $return->info['orders_id'] . '&action=edit&tabaction=getTransactionDetails'), 'primary', null, true);
          $refund_button = $this->getRefundButton($status, $order);
          $paypal_button = $this->_app->drawButton($this->_app->getDef('button_view_at_paypal'), 'https://www.' . ($pp_server == 'sandbox' ? 'sandbox.' : '') . 'paypal.com/cgi-bin/webscr?cmd=_view-a-trans&id=' . $status['Transaction ID'], 'info', 'target="_blank"', true);

          $tab_title = addslashes($this->_app->getDef('tab_title'));
          $tab_link = substr(tep_href_link('returns.php', tep_get_all_get_params()), strlen($base_url)) . '#section_paypal_content';
		  $complete = addslashes($this->_app->getDef('complete'));
		  $finalised = addslashes($this->_app->getDef('finalised') . ' ');

			if ($return->info['finalised'] == 1 && $return->info['refund_payment_name'] == 'Paypal') {
			$output = <<<EOD
<script>
$(function() {
  $('#returnTabs ul').append('<li><a href="{$tab_link}">{$tab_title}</a></li>');
});
</script>

<div id="section_paypal_content" style="padding: 10px;">
  {$finalised} {$info_button} {$paypal_button}
</div>
EOD;
			} elseif ($return->info['finalised'] == 1) {

			$output = <<<EOD
<script>
$(function() {
  $('#returnTabs ul').append('<li><a href="{$tab_link}">{$tab_title}</a></li>');
});
</script>

<div id="section_paypal_content" style="padding: 10px;">
	{$finalised}
</div>
EOD;
				} else {
			$output = <<<EOD
<script>
$(function() {
  $('#returnTabs ul').append('<li><a href="{$tab_link}">{$tab_title}</a></li>');
});
</script>

<div id="section_paypal_content" style="padding: 10px;">
  {$info_button} {$paypal_button} {$refund_button} 
</div>
EOD;
				}
		} else {
			
			$output = <<<EOD
<script>
$(function() {
  $('#returnTabs ul').append('<li><a href="{$tab_link}">{$tab_title}</a></li>');
});
</script>

<div id="section_paypal_content" style="padding: 10px;">
	{$complete}
</div>
EOD;
		
	//	}		
        }
      }

      return $output;
    }


    function getRefundButton($status, $order) {
      global $return;
	  $output = '';

      $tids = array();
	  $total_refunds = 0;
      $ppr_query = tep_db_query("select comments from orders_status_history where orders_id = '" . (int)$return->info['orders_id'] . "' and orders_status_id = '" . (int)OSCOM_APP_PAYPAL_TRANSACTIONS_ORDER_STATUS_ID . "' and comments like 'PayPal App: %' order by date_added desc");
      if ( tep_db_num_rows($ppr_query) ) {
        while ( $ppr = tep_db_fetch_array($ppr_query) ) {
          if ( strpos($ppr['comments'], 'PayPal App: PartialRefund') !== false ) {
			preg_match('/^PayPal App\: PartialRefund \(([0-9\.]+)\).*Transaction ID\: ([A-Za-z0-9]+)/s', $ppr['comments'], $ppr_matches);
			$total_refunds += $ppr_matches[1];
          } 
        }
	  }
      if ( $status['Payment Status'] == 'Completed' ) {
        $tids[$status['Transaction ID']]['Amount'] = $this->_app->formatCurrencyRaw($return->info['refund_amount'], $return->info['currency'], $return->info['currency_value']);
      
      }
	  
      $can_refund = false;
	  
	  foreach ( $tids as $value ) {
        if ( !isset($value['Refund']) ) {
		  $order_total = $this->_app->formatCurrencyRaw($order['total'], $order['currency'], $order['currency_value']);
		  $refunds_total = $total_refunds + $return->info['refund_amount'];
			if ($refunds_total < $order_total) {
			  $can_refund = true;
          break;
			}
        }
      }

      if ( $can_refund === true ) {
        $output .= $this->_app->drawButton($this->_app->getDef('button_dialog_refund'), '#', 'error', 'data-button="paypalButtonRefundTransaction"', true);
		$paypal_refund = $this->_app->formatCurrencyRaw($return->info['refund_amount'], $order['currency'], $order['currency_value']);
        $dialog_title = tep_output_string_protected($this->_app->getDef('dialog_refund_title'));
        $dialog_body = $this->_app->getDef('dialog_refund_body');
		$dialog_body .= tep_draw_hidden_field('refund_amount', $paypal_refund);
        $refund_link = tep_href_link('returns.php', 'page=' . $_GET['page'] . '&oID=' . $return->info['orders_id'] . '&rID=' . $return->info['returns_id'] . '&action=edit&tabaction=refundTransaction');
        $dialog_button_refund = addslashes($this->_app->getDef('dialog_refund_button_refund'));
        $dialog_button_cancel = addslashes($this->_app->getDef('dialog_refund_button_cancel'));
        $refund_fields = '';

        $counter = 0;

        foreach ( $tids as $key => $value ) {

		  $refund_fields .= '<p><input type="checkbox" name="ppRefund[]" value="' . $key . '" id="ppRefundPartial' . $counter . '"' . (isset($value['Refund']) ? ' disabled="disabled"' : '') . ' /> <label for="ppRefundPartial' . $counter . '"' . (isset($value['Refund']) ? ' style="text-decoration: line-through;"' : '') . '>' . $this->_app->getDef('dialog_refund_payment_title', array('amount' => $paypal_refund)) . '</label></p>';

          $counter++;
        }

        $output .= <<<EOD
<div id="paypal-dialog-refund" title="{$dialog_title}">
  <form id="ppRefundForm" action="{$refund_link}" method="post">
    <p>{$dialog_body}</p>

		{$refund_fields}
  </form>
</div>

<script>
$(function() {
  $('#paypal-dialog-refund').dialog({
    autoOpen: false,
    resizable: false,
    modal: true,
    buttons: {
      "{$dialog_button_refund}": function() {
        $('#ppRefundForm').submit();
      },
      "{$dialog_button_cancel}": function() {
        $(this).dialog('close');
      }
    }
  });

  $('a[data-button="paypalButtonRefundTransaction"]').click(function(e) {
    e.preventDefault();

    $('#paypal-dialog-refund').dialog('open');
  });
});
</script>
EOD;
      } else {
		  $output = $this->_app->getDef('dialog_refund_overage', array('amount' => $this->_app->formatCurrencyRaw($return->info['refund_amount'], $order['currency'], $order['currency_value']), 'total' => $order_total));
	  }

      return $output;
    }
  }
?>
