<?php
/**
  * RMA Return System for osCommerce Online Merchant
  *
  * Author: frankl
  *
  * Portions @copyright (c) 2017 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */

  class returns {
    var $info, $totals, $products, $customer, $delivery;

    function __construct($returns_id) {
      $this->info = array();
      $this->totals = array();
      $this->products = array();
      $this->customer = array();
      $this->delivery = array();

      $this->query($returns_id);
    }

    function query($returns_id) {
      global $languages_id;

      $return_query = tep_db_query("select rp.*, rr.return_reason_name, rs.returns_status_name from returned_products rp, returns_status rs, return_reasons rr where rp.returns_id = '" . (int)$returns_id . "' and rp.returns_status = rs.returns_status_id and rp.return_reason_id = rr.return_reason_id and rs.language_id = '" . (int)$languages_id . "' and rr.language_id = '" . (int)$languages_id . "'");
      $return = tep_db_fetch_array($return_query);
	  
	  $order_query = tep_db_query("select * from " . TABLE_ORDERS . " where orders_id = '" . (int)$return['orders_id'] . "'");
      $order = tep_db_fetch_array($order_query);

      $refund_payment_query = tep_db_query("select refund_payment_name, refund_payment_value, refund_payment_date, refund_payment_reference, refund_payment_deductions, customer_method, refund_payment_finalised from refund_payments where returns_id = '" . (int)$returns_id . "'");
      $refund_payment = tep_db_fetch_array($refund_payment_query);
	  
	  $refund_method_name_query = tep_db_query("select refund_method_name from refund_method rm where refund_method_id = '" . $refund_payment['customer_method'] . "' and rm.language_id = '" . (int)$languages_id . "'");
      $refund_method_name = tep_db_fetch_array($refund_method_name_query);

      $this->info = array('currency' => $order['currency'],
                          'currency_value' => $order['currency_value'],
                          'payment_method' => $order['payment_method'],
                          'rma_value' => $return['rma_value'],
                          'returns_id' => $return['returns_id'],
                          'cc_type' => $order['cc_type'],
                          'cc_owner' => $order['cc_owner'],
                          'cc_number' => $order['cc_number'],
                          'cc_expires' => $order['cc_expires'],
						  'returns_status_name' => $return['returns_status_name'],
                          'comments' => $return['comments'],
                          'date_added' => $return['date_added'],
                          'returns_status' => $return['returns_status'],
						  'return_reason_id' => $return['return_reason_id'],
						  'return_reason_name' => $return['return_reason_name'],
                          'date_finished' => $return['returns_date_finished'],
                          'orders_id' => $return['orders_id'],
                          'customer_method' => $refund_payment['customer_method'],
                          'refund_method_name' => $refund_method_name['refund_method_name'],
                          'refund_payment_name' => $refund_payment['refund_payment_name'],
						  'deductions' => $refund_payment['refund_payment_deductions'],
						  'finalised' => $refund_payment['refund_payment_finalised'],
                          'payment_reference' => $refund_payment['refund_payment_reference'],
                          'refund_amount' => $refund_payment['refund_payment_value'],
                          'refund_date' => $refund_payment['refund_payment_date'],
                          'last_modified' => $return['last_modified']);

      $this->customer = array('id' => $order['customers_id'],
							  'name' => $order['customers_name'],
                              'company' => $order['customers_company'],
                              'street_address' => $order['customers_street_address'],
                              'suburb' => $order['customers_suburb'],
                              'city' => $order['customers_city'],
                              'postcode' => $order['customers_postcode'],
                              'state' => $order['customers_state'],
                              'country' => $order['customers_country'],
                              'format_id' => $order['customers_address_format_id'],
                              'telephone' => $order['customers_telephone'],
                              'email_address' => $order['customers_email_address']);

      $this->delivery = array('name' => $order['delivery_name'],
                              'company' => $order['delivery_company'],
                              'street_address' => $order['delivery_street_address'],
                              'suburb' => $order['delivery_suburb'],
                              'city' => $order['delivery_city'],
                              'postcode' => $order['delivery_postcode'],
                              'state' => $order['delivery_state'],
                              'country' => $order['delivery_country'],
                              'format_id' => $order['delivery_address_format_id']);

      $this->billing = array('name' => $order['billing_name'],
                             'company' => $order['billing_company'],
                             'street_address' => $order['billing_street_address'],
                             'suburb' => $order['billing_suburb'],
                             'city' => $order['billing_city'],
                             'postcode' => $order['billing_postcode'],
                             'state' => $order['billing_state'],
                             'country' => $order['billing_country'],
                             'format_id' => $order['billing_address_format_id']);


 
	  $returns_products_query = tep_db_query("select orders_products_id, products_name, products_model, products_price, products_tax, products_quantity, final_price from " . TABLE_ORDERS_PRODUCTS . " where orders_id = '" . (int)$return['orders_id'] . "' and products_id = '" . (int)$return['products_id'] . "'");
	  $returns_products = tep_db_fetch_array($returns_products_query);
	  
	  
      $this->products = array('qty' => $return['products_quantity'],
                              'name' => $returns_products['products_name'],
                              'model' => $returns_products['products_model'],
							  'serial_number' => $return['products_serial_number'],
							  'products_returned' => $return['products_returned'],
                              'tax' => $returns_products['products_tax'],
                              'price' => $returns_products['products_price'],
                              'final_price' => $returns_products['final_price']);
							  
		$subindex = 0;
	
        $attributes_query = tep_db_query("select products_options, products_options_values, options_values_price, price_prefix from " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . " where orders_id = '" . (int)$return['orders_id'] . "' and orders_products_id = '" . (int)$returns_products['orders_products_id'] . "'");
		$this->products['check'] = array('orders_id' => $return['orders_id'], 'orders_products_id' => $returns_products['orders_products_id']);
        if (tep_db_num_rows($attributes_query)) {
          while ($attributes = tep_db_fetch_array($attributes_query)) {
            $this->products['attributes'][$subindex] = array('option' => $attributes['products_options'],
															 'value' => $attributes['products_options_values'],
															 'prefix' => $attributes['price_prefix'],
															 'price' => $attributes['options_values_price']);

            $subindex++;
          }
        }

    }
  }
?>