<?php
/**
  * RMA Return System for osCommerce Online Merchant
  *
  * Author: frankl
  *
  * Portions @copyright (c) 2017 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */

class ht_returns {

    var $code = 'ht_returns';
    var $group = 'header_tags';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
        $this->title = MODULE_HEADER_TAGS_RETURNS_TITLE;
        $this->description = MODULE_HEADER_TAGS_RETURNS_DESCRIPTION;

        if (defined('MODULE_HEADER_TAGS_RETURNS_STATUS')) {
            $this->sort_order = MODULE_HEADER_TAGS_RETURNS_SORT_ORDER;
            $this->enabled = (MODULE_HEADER_TAGS_RETURNS_STATUS == 'True');
        }
    }

    function execute() {
        global $PHP_SELF, $oscTemplate, $_GET, $order;
            if (basename($PHP_SELF) == 'account_history_info.php') {
				

		$order_status_id_query = tep_db_query("select orders_status from orders where orders_id = '" . (int)$_GET['order_id'] . "'");
		  $order_status_id = tep_db_fetch_array($order_status_id_query);  
		  $return_order_status_query = tep_db_query("select * from returns_configuration where returns_order_statuses = '" . $order_status_id['orders_status'] . "'");
			if (tep_db_num_rows($return_order_status_query)) { 
			  $limit_date = strtotime ( '+' . DAYS_FOR_REFUND . ' days', strtotime ($order->info['date_purchased']));
			  $today = strtotime('today');
				if ($limit_date > $today) {
				  if (sizeof($order->products) == 1) {
					$ordered_item_query = tep_db_query("select products_id, products_quantity from " . TABLE_ORDERS_PRODUCTS . " where orders_id = '" . (int)$_GET['order_id'] . "' limit 1");
					$ordered_item = tep_db_fetch_array($ordered_item_query);
					$returned_product_check_query = tep_db_query("select products_id, SUM(products_quantity) as total_returned from returned_products where orders_id = '" . (int)$_GET['order_id'] . "' and products_id = '" . (int)$ordered_item['products_id'] . "' limit 1");
					$returned_product_check = tep_db_fetch_array($returned_product_check_query);
					if (tep_db_num_rows($returned_product_check_query) && ($returned_product_check['total_returned'] >= $ordered_item['products_quantity'])) {

				  $button = '<span class="pull-right">' .  tep_draw_button(TEXT_CHECK_RETURN, 'fa fa-arrow-right', tep_href_link('returns_track.php', '', 'SSL')) . '</span>';

				} else {
				
				  $button = '<span class="pull-right">' . tep_draw_button(TEXT_RETURN_ITEM, 'fa fa-arrow-right', tep_href_link('return_product.php', 'orders_id=' . $_GET['order_id'] . '&products_id=' . $ordered_item['products_id'] . '&action=return_new', 'SSL')) . '</span>';
	
				}
			  } else {

				 $button = '<span class="pull-right">' . tep_draw_button(TEXT_RETURN_ITEM, 'fa fa-arrow-right', tep_href_link('return_product.php', 'orders_id=' . $_GET['order_id'] . '&action=new', 'SSL')) . '</span>';

			  }
			}
		}

		$output = <<<EOD
<script type="text/javascript">
    $(document).ready(function () {

        $('.page-header h1').append('{$button}');
    });
</script>
EOD;

                $oscTemplate->addBlock($output, $this->group);
        }
    }

    function isEnabled() {
        return $this->enabled;
    }

    function check() {
        return defined('MODULE_HEADER_TAGS_RETURNS_STATUS');
    }

    function install() {
        tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Module', 'MODULE_HEADER_TAGS_RETURNS_STATUS', 'True', 'Do you want to enable the module?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
        tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_HEADER_TAGS_RETURNS_SORT_ORDER', '2000', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }

    function remove() {
        tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
        return array('MODULE_HEADER_TAGS_RETURNS_STATUS', 'MODULE_HEADER_TAGS_RETURNS_SORT_ORDER');
    }

}

?>
