<?php
/**
  * RMA Return System for osCommerce Online Merchant
  *
  * Author: frankl
  *
  * Portions @copyright (c) 2017 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */

  class hook_admin_returns_coupon {
		

	function load_language() {
		  global $language;
      include_once(DIR_FS_CATALOG_LANGUAGES . $language . '/modules/hooks/admin/returns/' . basename(__FILE__));
		}

    function execute() {
      global $rID, $language, $return;
			$this->load_language();

      $output = '';

      $status = array();
		if ($_SESSION['coupon_errors']) {
			$coupon_errors = '<p><font color="red">' . $_SESSION['coupon_errors'] . '</font></p>';
		}
		
      $refund_amount_query = tep_db_query("SELECT refund_payment_date, refund_payment_value, refund_payment_deductions from refund_payments where returns_id = '" . (int)$rID . "'");
        if ( tep_db_num_rows($refund_amount_query)) {
			
          $tab_title = addslashes(TAB_RETURN_COUPON);
          $tab_link = substr(tep_href_link('returns.php', tep_get_all_get_params()), strlen($base_url)) . '#section_return_coupons';
		  $coupon_button = $this->coupon_button_create();
		  $finalised = TEXT_RETURN_FINALISED;

		if ($return->info['finalised'] == 1) {
			$output = <<<EOD
<script>
$(function() {
  $('#returnTabs ul').append('<li><a href="{$tab_link}">{$tab_title}</a></li>');
});
</script>

<div id="section_return_coupons" style="padding: 10px;">
	{$finalised}
</div>
EOD;
			} else {
			$output = <<<EOD
<script>
$(function() {
  $('#returnTabs ul').append('<li><a href="{$tab_link}">{$tab_title}</a></li>');
});
</script>

<div id="section_return_coupons" style="padding: 40px;">
 {$coupon_errors} {$coupon_button}
</div>
EOD;
			}

		unset($_SESSION['coupon_errors']);
      }

      return $output;
    }
	
	
	function coupon_button_create() {
	  global $return;
		
		$ccgv_check = false;
		if ( tep_db_num_rows(tep_db_query("show tables like 'coupons'")) == 1 ) {
		  $ccgv_check = true;
		  }
		  
		if ( tep_db_num_rows(tep_db_query("show tables like 'coupon_email_track'")) != 1 ) {
		  $ccgv_check = false;
		  }
				  
		$discount_coupons_check = false;
		if ( tep_db_num_rows(tep_db_query("show tables like 'discount_codes'")) == 1 ) {
		  $discount_coupons_check = true;
		  }
		if ( tep_db_num_rows(tep_db_query("show tables like 'customers_to_discount_codes'")) == 1 ) {
		  $discount_coupons_check = false;
		  }

		$output = tep_draw_button(IMAGE_CREATE_COUPON, 'disk', '#', 'primary', array('params' => 'data-button="couponButton"'));

        $dialog_title = tep_output_string_protected(DIALOG_COUPON_TITLE);
        $dialog_body = DIALOG_COUPON_BODY;

		
		if ($ccgv_check == true) { // CCGV exists
		
		$coupon_code = $this->create_coupon_code('salt', '5');
		$coupon_table_start = '<table cellpadding="5">' . "\n";
		$form_field_amount = '    <tr><td>' . tep_draw_input_field('coupon_amount', tep_round($return->info['refund_amount'], 2)) . '</td><td>' . TEXT_COUPON_AMOUNT . '</td></tr>';
		$form_field_ccid = '    <tr><td>' . tep_draw_input_field('coupon_code', $coupon_code) . '</td><td>' . TEXT_COUPON_CODE . '</td></tr>';
		$languages = tep_get_languages();
		$x = sizeof($languages);
        for ($i = 0, $n = sizeof($languages); $i < $n; $i++) {
          $language_id = $languages[$i]['id'];
		  $form_field_coupon_name .= tep_draw_hidden_field('coupon_name[' . $languages[$i]['id'] . ']', $return->info['rma_value']) . tep_draw_hidden_field('coupon_description[' . $languages[$i]['id'] . ']', TEXT_COUPON_DESCRIPTION . $return->info['rma_value']); 
		}
		$form_field_coupon_name_desc = '    <tr><td>' . $return->info['rma_value'] . '</td><td>' . TEXT_COUPON_NAME . '</td></tr>';
		$form_hidden_fields = tep_draw_hidden_field('coupon_uses_coupon', '1') . tep_draw_hidden_field('coupon_uses_user', '1');
		$form_field_products = '    <tr><td>' . tep_draw_input_field('coupon_products', '', 'placeholder="' . RETURNS_PLACEHOLDER_OPTIONAL . '"') . '</td><td>' . TEXT_COUPON_PRODUCTS . '</td></tr>';
		$form_field_categories = '    <tr><td>' . tep_draw_input_field('coupon_categories', '', 'placeholder="' . RETURNS_PLACEHOLDER_OPTIONAL . '"') . '</td><td>' . TEXT_COUPON_CATEGORIES . '</td></tr>';
		$form_field_start_date = '    <tr><td>' . tep_draw_input_field('coupon_start_date', '', 'id="coupon_start_date" placeholder="' . RETURNS_PLACEHOLDER_LEAVE_BLANK . '"') . '</td><td>' . TEXT_COUPON_START_DATE . '</td></tr>';
		$form_field_expire_date = '    <tr><td>' . tep_draw_input_field('coupon_expire_date', '', 'id="coupon_expire_date"  placeholder="' . RETURNS_PLACEHOLDER_REQUIRED . '"') . '</td><td>' . TEXT_COUPON_EXPIRE_DATE . '</td></tr>';
		$form_field_active = '    <tr><td colspan="2">' . tep_draw_radio_field('coupon_active', 'Y', true) . '&nbsp;' . TEXT_COUPON_IS_ACTIVE . '&nbsp;' . tep_draw_radio_field('coupon_active', 'N', false) . '&nbsp;' . TEXT_COUPON_NOT_ACTIVE . '</td></tr>';
		$coupon_table_end = '</table>' . "\n";
		
        $coupon_link = tep_href_link('returns.php', 'page=' . $_GET['page'] . '&oID=' . $_GET['oID'] . '&rID=' . $_GET['rID'] . '&action=edit&coupontabaction=coupon_create');
        $dialog_button_refund = addslashes(BUTTON_CREATE_COUPON);
        $dialog_button_cancel = addslashes(BUTTON_CANCEL_COUPON);

        $coupon_fields = '';

        $counter = 0;


		$coupon_fields .= '<p><input type="checkbox" name="doCoupon" value="true" id="doCoupon" /> <label for="doCoupon">' . TEXT_BUTTON_TITLE . '</label></p>';
		
        $output .= <<<EOD
<div id="coupon-dialog" title="{$dialog_title}">
  <form id="couponForm" action="{$coupon_link}" method="post"> 
    <p>{$dialog_body}</p>
	

		{$coupon_table_start} {$form_field_amount} {$form_field_ccid} {$form_field_coupon_name} {$form_field_coupon_name_desc} {$form_hidden_fields} {$form_field_products} {$form_field_categories} {$form_field_start_date} {$form_field_expire_date} {$form_field_active} {$coupon_table_end}
  </form>
</div>

<script>
$(function() {
  $('#coupon-dialog').dialog({
    autoOpen: false,
    resizable: false,
    modal: true,
    buttons: {
      "{$dialog_button_refund}": function() {
        $('#couponForm').submit();
      },
      "{$dialog_button_cancel}": function() {
        $(this).dialog('close');
      }
    }
  });

  $('a[data-button="couponButton"]').click(function(e) {
    e.preventDefault();

    $('#coupon-dialog').dialog('open');
  });
});
</script>
<script type="text/javascript">
$('#coupon_start_date,#coupon_expire_date').datepicker({
  dateFormat: 'yy-mm-dd',
  changeMonth: true,
  changeYear: true
});
</script>
EOD;
		
		} elseif ($discount_coupons_check == true ) {
			
		$coupon_code = $this->create_coupon_code('salt', '5');
		$coupon_table_start = '<table cellpadding="5">' . "\n";
		$form_field_amount = '    <tr><td>' . tep_draw_input_field('discount_values', tep_round($return->info['refund_amount'], 2)) . '</td><td>' . TEXT_COUPON_AMOUNT . '</td></tr>';
		$form_field_ccid = '    <tr><td>' . tep_draw_input_field('discount_codes', $coupon_code) . '</td><td>' . TEXT_COUPON_CODE . '</td></tr>';
		$form_field_ship = '    <tr><td>' . tep_draw_checkbox_field('shipping', '0', false) . '</td><td>' . TEXT_COUPON_SHIPPING . '</td></tr>';
		$form_hidden_fields = tep_draw_hidden_field('number_of_use', '1') . tep_draw_hidden_field('coupon_uses_user', '1') . tep_draw_hidden_field('orders_total', '2') . tep_draw_hidden_field('customers_id', $return->customer['id']) . tep_draw_hidden_field('minimum_order_amount', '0.1000');
		$form_field_products = '    <tr><td>' . tep_draw_input_field('products_id', '', 'placeholder="' . RETURNS_PLACEHOLDER_OPTIONAL . '"') . '</td><td>' . TEXT_COUPON_PRODUCTS . '</td></tr>';
		$form_field_categories = '    <tr><td>' . tep_draw_input_field('categories_id', '', 'placeholder="' . RETURNS_PLACEHOLDER_OPTIONAL . '"') . '</td><td>' . TEXT_COUPON_CATEGORIES . '</td></tr>';
		$form_field_manufacturers = '    <tr><td>' . tep_draw_input_field('manufacturers_id', '', 'placeholder="' . RETURNS_PLACEHOLDER_OPTIONAL . '"') . '</td><td>' . TEXT_COUPON_MANUFACTURERS . '</td></tr>';
		$form_field_excluded = '    <tr><td>' . tep_draw_input_field('excluded_products_id', '', 'placeholder="' . RETURNS_PLACEHOLDER_OPTIONAL . '"') . '</td><td>' . TEXT_COUPON_EXCLUDED . '</td></tr>';
		$form_field_specials = '    <tr><td colspan="2">' . tep_draw_radio_field('exclude_specials', '1', true) . '&nbsp;' . TEXT_COUPON_EXCLUDE_SPECIALS . '&nbsp;' . tep_draw_radio_field('exclude_specials', '0', false) . '&nbsp;' . TEXT_COUPON_INCLUDE_SPECIALS . '</td></tr>';
		$form_field_expire_date = '    <tr><td>' . tep_draw_input_field('expires_date', '', 'id="coupon_expire_date" placeholder="' . RETURNS_PLACEHOLDER_REQUIRED . '"') . '</td><td>' . TEXT_COUPON_EXPIRE_DATE . '</td></tr>';
		$form_field_active = '    <tr><td colspan="2">' . tep_draw_radio_field('status', '1', true) . '&nbsp;' . TEXT_COUPON_IS_ACTIVE . '&nbsp;' . tep_draw_radio_field('status', '0', false) . '&nbsp;' . TEXT_COUPON_NOT_ACTIVE . '</td></tr>';
		$coupon_table_end = '</table>' . "\n";
		
        $coupon_link = tep_href_link('returns.php', 'page=' . $_GET['page'] . '&oID=' . $_GET['oID'] . '&rID=' . $_GET['rID'] . '&action=edit&discountcoupontabaction=coupon_create');
        $dialog_button_refund = addslashes(BUTTON_CREATE_COUPON);
        $dialog_button_cancel = addslashes(BUTTON_CANCEL_COUPON);

        $coupon_fields = '';

        $counter = 0;


		$coupon_fields .= '<p><input type="checkbox" name="doCoupon" value="true" id="doCoupon" /> <label for="doCoupon">' . TEXT_BUTTON_TITLE . '</label></p>';

		

        $output .= <<<EOD
<div id="coupon-dialog" title="{$dialog_title}">
  <form id="couponForm" action="{$coupon_link}" method="post">
    <p>{$dialog_body}</p>
	

		{$coupon_table_start} {$form_field_amount} {$form_field_ccid} {$form_field_ship} {$form_hidden_fields} {$form_field_products} {$form_field_categories} {$form_field_manufacturers} {$form_field_excluded} {$form_field_specials} {$form_field_expire_date} {$form_field_active} {$coupon_table_end}
  </form>
</div>

<script>
$(function() {
  $('#coupon-dialog').dialog({
    autoOpen: false,
    resizable: false,
    modal: true,
    buttons: {
      "{$dialog_button_refund}": function() {
        $('#couponForm').submit();
      },
      "{$dialog_button_cancel}": function() {
        $(this).dialog('close');
      }
    }
  });

  $('a[data-button="couponButton"]').click(function(e) {
    e.preventDefault();

    $('#coupon-dialog').dialog('open');
  });
});
</script>
<script type="text/javascript">
$('#coupon_start_date,#coupon_expire_date').datepicker({
  dateFormat: 'yy-mm-dd',
  changeMonth: true,
  changeYear: true
});
</script>
EOD;

		} else {
				$output = "No compatible coupon system exists.";
		}

      return $output;
	}
	
	function create_coupon_code($salt, $length) {
      $ccid = md5(uniqid("","salt"));
      $ccid .= md5(uniqid("","salt"));
      $ccid .= md5(uniqid("","salt"));
      $ccid .= md5(uniqid("","salt"));
      srand((double)microtime()*1000000); // seed the random number generator
      $random_start = @rand(0, (128-$length));
      $good_result = 0;
		while ($good_result == 0) {
		  $id1 = substr($ccid, $random_start,$length);        
		  $query = tep_db_query("select coupon_code from coupons where coupon_code = '" . $id1 . "'");    
		    if (tep_db_num_rows($query) == 0) $good_result = 1;
		}
    return $id1;
  }

  } 
