<?php
/**
  * RMA Return System for osCommerce Online Merchant
  *
  * Author: frankl
  *
  * Portions @copyright (c) 2017 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */

  class hook_admin_returns_coupon_action {
    function load_language() {
		  global $language;
      include_once(DIR_FS_CATALOG_LANGUAGES . $language . '/modules/hooks/admin/returns/' . basename(__FILE__));
	}

    function execute() {
		global $messageStack, $currencies;
		
		$this->load_language();
	$check_status_query = tep_db_query("select customers_name, customers_email_address from orders where orders_id = '" . (int)$_GET['oID'] . "'");
    $check_status = tep_db_fetch_array($check_status_query);
   if ( isset($_GET['coupontabaction']) ) {
		 
	unset($_SESSION['coupon_errors']);
	$coupon_errors = '';
	$update_errors = 0;
      if (!$_POST['coupon_code'])  {
        $update_errors = 1;
        $messageStack->add_session(ERROR_NO_COUPON_CODE, 'error');
		$coupon_errors .= '<br>' . ERROR_NO_COUPON_CODE;
      } $coupon_code = $_POST['coupon_code'];
      $query1 = tep_db_query("select coupon_code from coupons where coupon_code = '" . tep_db_prepare_input($coupon_code) . "'");
      if (tep_db_num_rows($query1) && $_POST['coupon_code'] )  {
        $update_errors = 1;
        $messageStack->add_session(ERROR_COUPON_EXISTS, 'error');
		$coupon_errors .= '<br>' . ERROR_COUPON_EXISTS;
      }
	   if (!$_POST['coupon_expire_date']) {
        $update_errors = 1;
        $messageStack->add_session(ERROR_NO_COUPON_EXPIRE_DATE, 'error');
		$coupon_errors .= '<br>' . ERROR_NO_COUPON_EXPIRE_DATE;
      }

      if ($update_errors != 0) {
		$_SESSION['coupon_errors'] = $coupon_errors;
		 tep_redirect(tep_href_link('returns.php', 'page=' . $_GET['page'] . '&oID=' . $_GET['oID'] . '&rID=' . $_GET['rID'] . '&action=edit#section_return_coupons'));
	  } else {
		  unset($_SESSION['coupon_errors']);
	  $coupon_type = "F";  // F =  fixed amount discount code
        if ($_POST['coupon_free_ship']) {
			$coupon_type = 'S'; // S = free shipping coupon
		}
      $coupon_start_date = tep_db_prepare_input($_POST['coupon_start_date']);
	  $coupon_start_date = (date('Y-m-d') < $coupon_start_date) ? $coupon_start_date : 'now()';
      $sql_data_array = array('coupon_code' => tep_db_prepare_input($_POST['coupon_code']),
                              'coupon_amount' => tep_db_prepare_input($_POST['coupon_amount']),
                              'coupon_type' => tep_db_prepare_input($coupon_type),
                              'uses_per_coupon' => tep_db_prepare_input($_POST['coupon_uses_coupon']),
                              'uses_per_user' => tep_db_prepare_input($_POST['coupon_uses_user']),
                              'coupon_minimum_order' => tep_db_prepare_input($_POST['coupon_min_order']),
                              'restrict_to_products' => tep_db_prepare_input($_POST['coupon_products']),
                              'restrict_to_categories' => tep_db_prepare_input($_POST['coupon_categories']),
                              'coupon_start_date' => $coupon_start_date,
                              'coupon_expire_date' => tep_db_prepare_input($_POST['coupon_expire_date']),
							  'coupon_active' => tep_db_prepare_input($_POST['coupon_active']),
                              'date_created' => 'now()',
                              'date_modified' => 'now()');
        $languages = tep_get_languages();
        for ($i = 0, $n = sizeof($languages); $i < $n; $i++) {
          $language_id = $languages[$i]['id'];
          $desc_data_array[$i] = array('coupon_name' => tep_db_prepare_input($_POST['coupon_name'][$language_id]),
                                       'coupon_description' => tep_db_prepare_input($_POST['coupon_description'][$language_id]));
        }
          $query = tep_db_perform('coupons', $sql_data_array);
          $insert_id = tep_db_insert_id();
		  $languages = tep_get_languages();
          for ($i = 0, $n = sizeof($languages); $i < $n; $i++) {
            $language_id = $languages[$i]['id'];
            $desc_data_array[$i]['coupon_id'] = $insert_id;
            $desc_data_array[$i]['language_id'] = $language_id;
            tep_db_perform('coupons_description', $desc_data_array[$i]);
          }
		  
		    $return_details_query = tep_db_query("select rma_value, currency, currency_value from returned_products where returns_id = '" . (int)$_GET['rID'] . "'");
			$return_details = tep_db_fetch_array($return_details_query);
			$email_coupon_expire_date = tep_date_short($_POST['coupon_expire_date']);

            $email = STORE_NAME . "\n" . EMAIL_SEPARATOR . "\n" . EMAIL_TEXT_RETURNS_NUMBER . ' ' . $return_details['rma_value'] . "\n\n" . EMAIL_TEXT_RETURNS_URL . ' ' . tep_catalog_href_link('returns_track.php', 'action=returns_show&rma=' . $return_details['rma_value'], 'SSL') . "\n\n" . EMAIL_TEXT_COUPON_AMOUNT . $currencies->format($_POST['coupon_amount'], true, $return_details['currency'], $return_details['currency_value']) . "\n\n" . EMAIL_TEXT_COUPON_IS . $_POST['coupon_code'] . "\n\n" . EMAIL_TEXT_COUPON_REMEMBER . EMAIL_COUPON_EXPIRE_REMINDER . $email_coupon_expire_date . "\n\n" . sprintf(EMAIL_COUPON_MINIMUM_AMOUNT, $currencies->format($_POST['coupon_amount'], true, $return_details['currency'], $return_details['currency_value']))  . "\n\n" . EMAIL_COUPON_SIGN_OFF . "\n" . HTTP_SERVER . DIR_WS_CATALOG;

            tep_mail($check_status['customers_name'], $check_status['customers_email_address'], EMAIL_TEXT_COUPON_SUBJECT . ' ' . $return_details['rma_value'], $email, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

			$return_comment = 'Discount Voucher issued: (' . $_POST['coupon_amount'] . ')' . "\n" .
							  'Coupon Code: ' . $_POST['coupon_code'] . "\n" .
							  'Expiry Date: ' . $email_coupon_expire_date . "\n";

            $returns_data_array = array('returns_id' => $_GET['rID'],
										'returns_status_id' => RETURNS_PAYPAL_TRANSACTIONS_ORDER_STATUS_ID,
										'date_added' => 'now()',
										'customer_notified' => '0',
										'comments' => $return_comment);

            tep_db_perform('returns_status_history', $returns_data_array);
			
			$customer_return_comment = 'Your return has been completed' . "\n" .
									   'Discount Voucher issued: (' . $_POST['coupon_amount'] . ')' . "\n" .
									   'Coupon Code: ' . $_POST['coupon_code'] . "\n" .
									   'Expiry Date: ' . $email_coupon_expire_date . "\n";

            $customer_returns_data_array = array('returns_id' => $_GET['rID'],
												 'returns_status_id' => RETURNS_CLOSED_TRANSACTIONS_ORDER_STATUS_ID,
												 'date_added' => 'now()',
												 'customer_notified' => '1',
												 'comments' => $customer_return_comment);

            tep_db_perform('returns_status_history', $customer_returns_data_array);
			
			tep_db_query("update refund_payments set refund_payment_name = 'Discount Coupon', refund_payment_finalised = 1 where returns_id = '" . (int)$_GET['rID'] . "'");
			tep_db_query("update returned_products set returns_status = '" . RETURNS_CLOSED_TRANSACTIONS_ORDER_STATUS_ID . "' where returns_id = '" . (int)$returns['returns_id'] . "'");
		  
		  $messageStack->add_session(SUCCESS_COUPON_CREATED, 'success');
		  tep_redirect(tep_href_link('returns.php', 'page=' . $_GET['page'] . '&oID=' . $_GET['oID'] . '&rID=' . $_GET['rID'] . '&action=edit#section_status_history_content'));
      }
	}
	
	if ( isset($_GET['discountcoupontabaction']) ) {
		 
	unset($_SESSION['coupon_errors']);
	$coupon_errors = '';
	$update_errors = 0;
      if (!$_POST['discount_codes'])  {
        $update_errors = 1;
        $messageStack->add_session(ERROR_NO_COUPON_CODE, 'error');
		$coupon_errors .= '<br>' . ERROR_NO_COUPON_CODE;
      }
	  $discount_code = $_POST['discount_codes'];
      $query1 = tep_db_query("select discount_codes from discount_codes where discount_codes = '" . tep_db_prepare_input($discount_code) . "'");
      if (tep_db_num_rows($query1) && $_POST['discount_codes'] )  {
        $update_errors = 1;
        $messageStack->add_session(ERROR_COUPON_EXISTS, 'error');
		$coupon_errors .= '<br>' . ERROR_COUPON_EXISTS;
      }
	   if (!$_POST['expires_date']) {
        $update_errors = 1;
        $messageStack->add_session(ERROR_NO_COUPON_EXPIRE_DATE, 'error');
		$coupon_errors .= '<br>' . ERROR_NO_COUPON_EXPIRE_DATE;
      }

      if ($update_errors != 0) {
		$_SESSION['coupon_errors'] = $coupon_errors;
		 tep_redirect(tep_href_link('returns.php', 'page=' . $_GET['page'] . '&oID=' . $_GET['oID'] . '&rID=' . $_GET['rID'] . '&action=edit#section_return_coupons'));
	  } else {
		  unset($_SESSION['coupon_errors']);
      $sql_data_array = array('products_id' => tep_db_prepare_input($_POST['products_id']),
							  'categories_id' => tep_db_prepare_input($_POST['categories_id']),							  
                              'manufacturers_id' => tep_db_prepare_input($_POST['manufacturers_id']),
							  'excluded_products_id' => tep_db_prepare_input($_POST['excluded_products_id']),
							  'customers_id' => tep_db_prepare_input($_POST['customers_id']),
							  'shipping' => tep_db_prepare_input($_POST['shipping']),
							  'exclude_specials' => tep_db_prepare_input($_POST['exclude_specials']),							  
							  'discount_codes' => tep_db_prepare_input($_POST['discount_codes']),
							  'discount_values' => tep_db_prepare_input($_POST['discount_values']),
							  'minimum_order_amount' => tep_db_prepare_input($_POST['minimum_order_amount']),
							  'expires_date' => tep_db_prepare_input($_POST['expires_date']),
                              'number_of_use' => tep_db_prepare_input($_POST['number_of_use']),
                              'status' => tep_db_prepare_input($_POST['status']));
       
          $query = tep_db_perform('discount_codes', $sql_data_array);
		  
		  	$return_details_query = tep_db_query("select rma_value, currency, currency_value from returned_products where returns_id = '" . (int)$_GET['rID'] . "'");
			$return_details = tep_db_fetch_array($return_details_query);
			$email_coupon_expire_date = tep_date_short($_POST['expires_date']);

            $email = STORE_NAME . "\n" . EMAIL_SEPARATOR . "\n" . EMAIL_TEXT_RETURNS_NUMBER . ' ' . $return_details['rma_value'] . "\n\n" . EMAIL_TEXT_RETURNS_URL . ' ' . tep_catalog_href_link('returns_track.php', 'action=returns_show&rma=' . $return_details['rma_value'], 'SSL') . "\n\n" . EMAIL_TEXT_COUPON_AMOUNT . $currencies->format($_POST['discount_values'], true, $return_details['currency'], $return_details['currency_value']) . "\n\n" . EMAIL_TEXT_COUPON_IS . $_POST['discount_codes'] . "\n\n" .EMAIL_TEXT_COUPON_REMEMBER . EMAIL_COUPON_EXPIRE_REMINDER . $email_coupon_expire_date . "\n\n" . sprintf(EMAIL_COUPON_MINIMUM_AMOUNT, $currencies->format($_POST['discount_values'], true, $return_details['currency'], $return_details['currency_value']))  . "\n\n" . EMAIL_COUPON_SIGN_OFF . "\n" . HTTP_SERVER . DIR_WS_CATALOG;

            tep_mail($check_status['customers_name'], $check_status['customers_email_address'], EMAIL_TEXT_COUPON_SUBJECT . ' ' . $return_details['rma_value'], $email, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

			$return_comment = 'Discount Voucher issued: (' . $_POST['discount_values'] . ')' . "\n" .
							  'Coupon Code: ' . $_POST['discount_codes'] . "\n" .
							  'Expiry Date: ' . $email_coupon_expire_date . "\n";

            $returns_data_array = array('returns_id' => $_GET['rID'],
										'returns_status_id' => RETURNS_PAYPAL_TRANSACTIONS_ORDER_STATUS_ID,
										'date_added' => 'now()',
										'customer_notified' => '0',
										'comments' => $return_comment);

            tep_db_perform('returns_status_history', $returns_data_array);
			
			$customer_return_comment = 'Your return has been completed' . "\n" .
									   'Discount Voucher issued: (' . $_POST['discount_values'] . ')' . "\n" .
									   'Coupon Code: ' . $_POST['discount_codes'] . "\n" .
									   'Expiry Date: ' . $email_coupon_expire_date . "\n";

            $customer_returns_data_array = array('returns_id' => $_GET['rID'],
										'returns_status_id' => RETURNS_CLOSED_TRANSACTIONS_ORDER_STATUS_ID,
										'date_added' => 'now()',
										'customer_notified' => '1',
										'comments' => $customer_return_comment);

            tep_db_perform('returns_status_history', $customer_returns_data_array);
			
			tep_db_query("update refund_payments set refund_payment_name = 'Discount Coupon', refund_payment_finalised = 0 where returns_id = '" . (int)$_GET['rID'] . "'");
			tep_db_query("update returned_products set returns_status = '" . RETURNS_CLOSED_TRANSACTIONS_ORDER_STATUS_ID . "' where returns_id = '" . (int)$returns['returns_id'] . "'");
		  
		  $messageStack->add_session(SUCCESS_COUPON_CREATED, 'success');


		  tep_redirect(tep_href_link('returns.php', 'page=' . $_GET['page'] . '&oID=' . $_GET['oID'] . '&rID=' . $_GET['rID'] . '&action=edit#section_status_history_content'));
      }
	}
	
	
    }
  }
?>
