<?php
/**
  * RMA Return System for osCommerce Online Merchant
  *
  * Author: frankl
  *
  * Portions @copyright (c) 2017 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */

  require('includes/application_top.php');

  require('includes/languages/' . $language . '/return_product.php');

  $breadcrumb->add(NAVBAR_TITLE, tep_href_link('return_product.php'));
  
  if (!tep_session_is_registered('customer_id')) {
     $navigation->set_snapshot();
     tep_redirect(tep_href_link('login.php', '', 'SSL'));
  }
  
  if ($_GET['products_id']) {
	  $products_id = $_GET['products_id'];
  } else if ($_POST['products_id']) {
	  $products_id = $_POST['products_id'];
  } else {
	  $products_id = '';
  }

  require('includes/classes/order.php');
  //check if order ID belongs to current customer!
  $order_and_customer_query = tep_db_query("SELECT * FROM orders where customers_id = '" . $customer_id . "' and orders_id = '" . (int)$_GET['orders_id'] . "'");
   if (!tep_db_num_rows($order_and_customer_query)) {
        tep_redirect(tep_href_link('account_history.php', '', 'SSL'));
   }
   //eof check
  $order = new order($_GET['orders_id']);
  
  // check if order is in the allowed status for return
  $order_status_id_query = tep_db_query("select orders_status from orders where orders_id = '" . (int)$_GET['orders_id'] . "'");
  $order_status_id = tep_db_fetch_array($order_status_id_query);  
  $return_order_status_query = tep_db_query("select * from returns_configuration where returns_order_statuses = '" . (int)$order_status_id['orders_status'] . "'");
	if (!tep_db_num_rows($return_order_status_query)) {
		tep_redirect(tep_href_link('account_history_info.php', 'order_id=' . $_GET['orders_id'], 'SSL'));
		die;
	}
	
  // check if the order is within the time limit allowed for returns
  $limit_date = strtotime ( '+' . DAYS_FOR_REFUND . ' days', strtotime ($order->info['date_purchased']));
  $today = strtotime('today');
	if ($limit_date < $today) {
	  tep_redirect(tep_href_link('account_history_info.php', 'order_id=' . $_GET['orders_id'], 'SSL'));
	  die;
	}

 // check to find out what the default reason & refund method for returning a product is
 $default_priority_query = tep_db_query("SELECT configuration_value FROM configuration where configuration_key = 'DEFAULT_RETURN_REASON'");
 $default_priority = tep_db_fetch_array($default_priority_query);
 $default_refund_query = tep_db_query("SELECT configuration_value FROM configuration where configuration_key = 'DEFAULT_REFUND_METHOD'");
 $default_refund = tep_db_fetch_array($default_refund_query);
 
 //create a random easily remembered return number
 function tep_create_rma_value($length) {
	$chars = '23456789ABCDEFGHJKLMNPQRSTUVWXYZ';
	$rand_rma = '';
	for ($i = 0; $i < $length; $i++) {
      $rand_rma .= $chars[mt_rand(0, strlen($chars)-1)];
	}
	$pass = false;
	while (!$pass) {
	  $rma_value_check_query = tep_db_query("select rma_value from returned_products where rma_value = '" . $rand_rma . "'");
	  if (!tep_db_num_rows($rma_value_check_query)) {
        $pass = true;
	  } else {
		for ($i = 0; $i < $length; $i++) {
		  $rand_rma .= $chars[mt_rand(0, strlen($chars)-1)];
		}  
	  }
	}
	return $rand_rma;
  }


  if (!$_POST['action']){
      $_POST['action'] = 'new';
  }

  if ($_GET['action']) {
    switch ($_GET['action']) {
      case 'insert':
      case 'update':
         // carry out a query on all the existing orders tables, to get the required information
         $rma_create = tep_create_rma_value(5);
         $returns_status_query = tep_db_query("SELECT configuration_value FROM configuration where configuration_key = 'DEFAULT_RETURN_STATUS_ID'");
         $default_return = tep_db_fetch_array($returns_status_query);
         $order_returns_query = tep_db_query("SELECT * FROM orders o, orders_products op where o.orders_id = op.orders_id and o.orders_id = '" . (int)$_GET['orders_id'] . " ' and op.products_id = '" . (int)$products_id . "'");
         $orders_return = tep_db_fetch_array($order_returns_query);

         if ($_POST['returns_quantity'] > $orders_return['products_quantity']) {
			 $messageStack->add_session('returns', TEXT_RETURNS_ERROR_QUANTITY, 'error');
			 tep_redirect(tep_href_link('return_product.php', 'action=return_new&orders_id=' . (int)$_GET['orders_id'] . '&products_id=' . (int)$_GET['products_id']), 'SSL');

         }

         $customers_id = $orders_return['customers_id'];
         $rma_value = tep_db_prepare_input($rma_create);
		 $email_link = tep_href_link('returns_track.php', '', 'SSL', false);
         $orders_id = $_GET['orders_id'];
         $comments = tep_db_prepare_input($_POST['returns_comments']);
         $returns_status =  $default_return['configuration_value'];
         $returns_reason = tep_db_prepare_input($_POST['return_reason_id']);
		 $customers_name = $orders_return['customers_name'];
		 $customers_email = $_POST['returns_user_email'];
		 $final_price = tep_add_tax($orders_return['final_price'] * $_POST['returns_quantity'], $orders_return['products_tax'], true);
         $products_quantity = $_POST['returns_quantity'];
		 if (tep_not_null($orders_return['products_serial_number'])) {
			 $serial_number = $orders_return['products_serial_number'];
		 } else {
			 $serial_number = tep_db_prepare_input($_POST['products_serial_number']);
		 }
         $currency = $orders_return['currency'];
         $currency_value = $orders_return['currency_value'];
         $refund_method = $_POST['refund_method'];
         $returns_error = false;
 // error checking elsewhere

   if (!$returns_error) {
          $sql_data_array = array('customers_id' => $customers_id,
                                  'rma_value' => $rma_value,
                                  'orders_id' => $orders_id,
                                  'returns_status' => $returns_status,
                                  'return_reason_id' => $returns_reason,
								  'products_id' => $products_id,
								  'products_quantity' => $products_quantity,
								  'products_serial_number' => $serial_number,
                                 );
          if ($_GET['action'] == 'insert') {
			$total_ordered_query = tep_db_query("select products_quantity from orders_products where products_id = '" . (int)$_GET['products_id'] . "' and orders_id = '" . $_GET['orders_id'] . "'");
			$total_ordered = tep_db_fetch_array($total_ordered_query);
			$total_products_query = tep_db_query("select sum(products_quantity) as total FROM returned_products where products_id = '" . (int)$_GET['products_id'] . "' and orders_id = '" . $_GET['orders_id'] . "'");
            $total_products = tep_db_fetch_array($total_products_query);
				if (($_POST['returns_quantity'] + $total_products['total']) >= $total_ordered['products_quantity']+1) {
				  $messageStack->add_session('returns_track', TEXT_RETURNS_ALREADY_RETURNED, 'error');
				  tep_redirect(tep_href_link('returns_track.php', '', 'SSL'));
				}
			
			$insert_sql_data = array('date_added' => 'now()');

            tep_db_perform('returned_products', $sql_data_array);
            $returns_id = tep_db_insert_id();

            tep_db_perform('returned_products', $insert_sql_data, 'update', 'returns_id = \'' . $returns_id . '\'');
          $returns_payment_sql = array('returns_id' => $returns_id,
                                       'refund_payment_name' => '',
                                       'refund_payment_value' => $final_price,
									   'customer_method' => $refund_method
                                       );

            tep_db_perform('refund_payments', $returns_payment_sql);

          }

		  // Add returns status to returns status history table
		  tep_db_query("insert into returns_status_history (returns_id , returns_status_id, date_added, customer_notified, comments) values ('" . $returns_id . "','" .   $returns_status . "', now(), 1,'" . tep_db_input($comments) . "')");

          // now send email to customer

           require('includes/languages/' . $language . '/return_emails.php');
           $email_text = EMAIL_TEXT_RETURNS_TITLE;
           $email_text .= EMAIL_TEXT_RETURNS_THANKS . EMAIL_TEXT_RETURNS_SENT . EMAIL_TEXT_RETURNS_CLOSE . EMAIL_TEXT_RETURNS_CONTACT_OPEN . EMAIL_TEXT_RETURNS_WARNING;
           tep_mail($customers_name, $customers_email, EMAIL_TEXT_RETURNS_SUBJECT . ' ' . $rma_value, nl2br($email_text), STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

          // now send an email to the default administrator to let them know of new return
             $email_text_admin = EMAIL_TEXT_RETURNS_THANKS_ADMIN . EMAIL_TEXT_RETURNS_ADMIN;
             tep_mail(STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS , EMAIL_TEXT_RETURNS_SUBJECT_ADMIN .' ' . $rma_value, nl2br($email_text_admin), STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

          // redirect to confirmation
            tep_redirect(tep_href_link('return_product.php' . '?action=sent&rma_value='. $rma_value . '&return_id=' . $returns_id . '&orders_id=' . $orders_id));
        } else {
          $_GET['action'] = 'new';
        }
        break;
       case 'default':
       tep_redirect(tep_href_link('index.php'));
       break;
    }
  }

  require('includes/template_top.php');
?>
<div class="page-header">
  <h1><?php echo HEADING_TITLE; ?></h1>
</div>
<?php
  if ($messageStack->size('returns') > 0) {
    echo $messageStack->output('returns');
  }
?>

<div class="contentContainer">
  
<?php
  if ($_GET['action'] == 'sent'){
	$account_query = tep_db_query("SELECT customers_firstname, customers_lastname, customers_email_address FROM customers where customers_id = '" . $customer_id . "'");
	$account = tep_db_fetch_array($account_query);
	$customers_email_address = $account['customers_email_address'];
	$customers_first_name = $account['customers_firstname'];
?>
  <div class="contentText">	        
		<div class="col-md-12">
		<div class="panel panel-success">
		  <div class="panel-heading">
			<h3 class="panel-title"><?php echo TEXT_RETURNS_YOUR_RMA_NUMBER . $_GET['rma_value']; ?></h3>
		  </div>
		  <div class="panel-body">
		    <p><strong><?php echo sprintf(TEXT_RETURNS_THANK_YOU, $customers_first_name); ?></strong><p>
			<p><?php echo sprintf(TEXT_RETURNS_SUCCESS, $customers_email_address); ?></p>
		  </div>
		</div>
	  </div>
  </div> <!-- end of contentText -->	  			
  <div class="buttonSet">
    <div class="text-right"><?php echo tep_draw_button(IMAGE_BUTTON_BACK_TO_ORDER, 'fa fa-angle-left', tep_href_link('account_history_info.php', 'order_id=' . $_GET['orders_id'], 'SSL')); ?></div>
  </div>
      <?php
	  } else if ($_GET['action'] == 'return_new'){
        $account_query = tep_db_query("SELECT customers_firstname, customers_lastname, customers_email_address FROM customers where customers_id = '" . $customer_id . "'");
        $account = tep_db_fetch_array($account_query);
        // query the order table, to get all the product details
        $returned_products_query = tep_db_query("SELECT * FROM orders_products op, orders o where o.orders_id = op.orders_id and op.orders_id = '" . $_GET['orders_id'] . "' and products_id = '" . $products_id . "'");
        $returned_products = tep_db_fetch_array($returned_products_query);
		
		$subindex = 0;
        $attributes_query = tep_db_query("select products_options, products_options_values, options_values_price, price_prefix from " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . " where orders_id = '" . (int)$_GET['orders_id'] . "' and orders_products_id = '" . (int)$returned_products['orders_products_id'] . "'");
        if (tep_db_num_rows($attributes_query)) {
			$blah = 'blah';
          while ($attributes = tep_db_fetch_array($attributes_query)) {
            $product_attributes['attributes'][$subindex] = array('option' => $attributes['products_options'],
															 'value' => $attributes['products_options_values'],
															 'prefix' => $attributes['price_prefix'],
															 'price' => $attributes['options_values_price']);

            $subindex++;
          }
        }
		
	  ?>
      <?php echo tep_draw_form('longsubmit', tep_href_link('return_product.php', 'action=insert&orders_id=' . $_GET['orders_id'] . '&products_id=' . $products_id, 'SSL'), 'post', 'class="form-horizontal"', true); ?>
<div class="contentText">	  
	
	<h2><?php echo TEXT_RETURNS_HEADING; ?></h2>
<?php
if (RETURNS_SHOW_TERMS_AND_CONDITIONS == '1') {
?>
<script>
$(document).ready(function(){
	$('.returnTermsModal').modal({
  backdrop: 'static',
  keyboard: true
})
$('.returnTermsModal').modal('show');
	
	


});
$(document).ready(function(){
	$("#send_terms").click(function(e) {
    e.preventDefault();
    $.ajax({
        type: "POST",
        url: "returns_send_terms.php",
        data: { 
          name: '<?php echo $account['customers_firstname']; ?>',
		  email: '<?php echo $account['customers_email_address']; ?>',
		  language_id: '<?php echo $languages_id; ?>'
        },
		dataType: 'json',
        success: function(data) {
        if(data.result) {
		  $('.sentError').hide();
		  $('#send_terms').text('<?php echo TEXT_RETURNS_MODAL_TERMS_AND_CONDITIONS_SENT; ?>');
		  $("#send_terms").attr( "disabled", "disabled" );
        }
        else {
          $('.sentError').show();
		  $('.sentError').text('<?php echo TEXT_RETURNS_MODAL_TERMS_AND_CONDITIONS_ERROR; ?>');
        }
      }
    });
});
});
</script>
	 <div class="returnTermsModal modal fade in" tabindex="-1" role="dialog">
	  <div class="modal-dialog" role="document">
		<div class="modal-content">
		  <div class="modal-header">
			<h4 class="modal-title"><?php echo HEADING_RETURNS_MODAL_TERMS_AND_CONDITIONS; ?></h4>
		  </div>
		  <div class="modal-body">
			<p><strong><?php echo HEADING_RETURNS_MODAL_PLEASE_READ; ?></strong></p>
			<hr>
			<p><?php 
				$terms_and_conditions_query = tep_db_query("select terms_and_conditions from returns_text where language_id = '" . $languages_id . "'");
				$terms_and_conditions = tep_db_fetch_array($terms_and_conditions_query);
				echo nl2br($terms_and_conditions['terms_and_conditions']); ?></p>
		  </div>
		  <div class="modal-footer">
			<span class="sentError text-danger"></span><button type="button" class="btn btn-default" id="send_terms"><?php echo BUTTON_RETURNS_MODAL_TERMS_AND_CONDITIONS_EMAIL; ?></button>
			<button type="button" class="btn btn-primary" data-dismiss="modal"><?php echo BUTTON_RETURNS_MODAL_TERMS_AND_CONDITIONS_AGREE; ?></button><br />
			<a href="<?php echo tep_href_link('account_history_info.php', 'orders_id=' . $_GET['orders_id'], 'SSL'); ?>"><small><?php echo TEXT_RETURNS_MODAL_TERMS_AND_CONDITIONS_CANCEL; ?></small></a>
		  </div>
		</div><!-- /.modal-content -->
	  </div><!-- /.modal-dialog -->
	</div><!-- /.modal -->
	<div class="alert-dismissible success hide">
	  <button type="button" class="close" data-dismiss="alert">×</button>
<?php echo TEXT_RETURNS_MODAL_TERMS_AND_CONDITIONS_SENT; ?>    </div>
<?php
}
?>	
	<div class="row">
	  <div class="col-md-12">
		<div class="panel panel-primary">
		  <div class="panel-heading">
			<h3 class="panel-title"><?php echo TEXT_RETURNS_PRODUCT_RETURN; ?></h3>
		  </div>
		  <div class="panel-body">
			<table class="table">
			  <tr>
				<th width="80"><?php echo HEADING_RETURNS_QUANTITY; ?></th>
				<th><?php echo HEADING_RETURNS_PRODUCTS; ?></th>
				<th><?php echo HEADING_RETURNS_TOTAL; ?></th>
			  </tr>
			  <tr>
				<td width="20"><?php
					$total_products_query = tep_db_query("select sum(products_quantity) as total FROM returned_products where products_id = '" . $products_id . "' and orders_id = '" . $_GET['orders_id'] . "'");
					$total_products = tep_db_fetch_array($total_products_query);
					$returnable = $returned_products['products_quantity'] - $total_products['total'];
					if ($returnable < '2') {
					  echo tep_draw_hidden_field('returns_quantity', '1') . '1';
					} else {
					  echo tep_draw_input_field('returns_quantity', '1', 'required aria-required="true" id="returns_quantity" placeholder="1"');
					}
					?></td>
				<td><?php echo $returned_products['products_name']; 
						if ($returned_products['products_quantity'] > '1') {
							echo '<small> - <em>(' . $returnable . ' can be returned)</em></small>';
						}
						for ($j = 0, $k = sizeof($product_attributes['attributes']); $j < $k; $j++) {
							    echo '<br /><nobr><small>&nbsp;<i> - ' . $product_attributes['attributes'][$j]['option'] . ': ' . $product_attributes['attributes'][$j]['value'];
							    if ($product_attributes['attributes'][$j]['price'] != '0') echo ' (' . $product_attributes['attributes'][$j]['prefix'] . $currencies->format($product_attributes['attributes'][$j]['price'] * $returned_products['products_quantity'], true, $returned_products['currency'], $returned_products['currency_value']) . ')';
							    echo '</i></small></nobr>';
							  }
				?></td>
				<td><?php echo $currencies->format(($returned_products['products_price'] + (tep_calculate_tax(($returned_products['products_price']),($returned_products['products_tax']))))); ?></td>
			  </tr>
			</table>
		  </div>
		</div>
	  </div>
	  <?php
	  if (RETURNS_SHOW_SERIAL_NUMBER == '1') {
		if (RETURNS_SHOW_SERIAL_NUMBER_OPTION == '1') {
		  $required = 'required aria-required="true"';
		  $placeholder = TEXT_RETURNS_ENTER_SERIAL_NUMBER_REQUIRED;
	    } else {
	      $required = '';
		  $placeholder = TEXT_RETURNS_ENTER_SERIAL_NUMBER_OPTIONAL;
	    }
	  ?>
	  <div class="col-md-12">
		<div class="panel panel-info">
		  <div class="panel-heading">
			<h3 class="panel-title"><?php echo TEXT_RETURNS_SERIAL_NUMBER; ?></h3>
		  </div>
		  <div class="panel-body">
			<?php echo tep_draw_input_field('products_serial_number', $serial_number, $required . ' id="products_serial_number" placeholder="' . $placeholder . '"');; ?>
		  </div>
		</div>
	  </div>
	  <?php
	  }
	  ?>
	  	
	    <div class="col-md-6">
		  <div class="panel panel-warning">
		    <div class="panel-heading">
			  <h3 class="panel-title"><?php echo TEXT_RETURNS_BILLING_ADDRESS; ?></h3>
		    </div>
		    <div class="panel-body">
			  <?php echo tep_address_format($order->billing['format_id'], $order->billing, 1, ' ', '<br>'); ?>
		    </div>
		  </div>
	    </div>
	    <div class="col-md-6">
		  <div class="panel panel-info">
		    <div class="panel-heading">
			  <h3 class="panel-title"><?php echo TEXT_RETURNS_DELIVERY_ADDRESS; ?></h3>
		    </div>
		    <div class="panel-body">
			  <?php echo tep_address_format($order->delivery['format_id'], $order->delivery, 1, ' ', '<br>'); ?>
		    </div>
		  </div>
	    </div>

	    <div class="col-md-4">
		  <div class="panel panel-warning">
		    <div class="panel-heading">
			  <h3 class="panel-title"><?php echo TEXT_RETURNS_USER_EMAIL; ?></h3>
		    </div>
		    <div class="panel-body">
			  <?php echo $account['customers_email_address'] . tep_draw_hidden_field('returns_user_email', $account['customers_email_address']); ?>
		    </div>
		  </div>
	    </div>
	  
	    <div class="col-md-4">
		  <div class="panel panel-info">
		    <div class="panel-heading">
			  <h3 class="panel-title"><?php echo TEXT_RETURNS_WHY_RETURN; ?></h3>
		    </div>
		    <div class="panel-body">
			  <?php
			  $priority_array = array();
              $priority_query = tep_db_query("select return_reason_id, return_reason_name from return_reasons where language_id = '" . $languages_id . "' order by return_reason_id desc");
              while ($priority_values = tep_db_fetch_array($priority_query)) {
                $priority_array[] = array('id' => $priority_values['return_reason_id'], 
										  'text' => substr($priority_values['return_reason_name'], 0, MAX_DISPLAY_MANUFACTURER_NAME_LEN));
              }
              echo tep_draw_pull_down_menu('return_reason_id', $priority_array, $default_priority['configuration_value'], 'id="return_reason_id" aria-describedby="returnReason"');
			  ?>
		    </div>
		  </div>
	    </div>
	  
	    <div class="col-md-4">
		  <div class="panel panel-warning">
		    <div class="panel-heading">
			  <h3 class="panel-title"><?php echo TEXT_RETURNS_PREF_REFUND_METHOD; ?></h3>
		    </div>
		    <div class="panel-body">
			  <?php
			  $refund_array = array();
              $refund_query = tep_db_query("select refund_method_id, refund_method_name from refund_method where language_id = '" . $languages_id . "' order by refund_method_id asc");
              while ($refund_values = tep_db_fetch_array($refund_query)) {
                $refund_array[] = array('id' => $refund_values['refund_method_id'], 
										'text' => substr($refund_values['refund_method_name'], 0, MAX_DISPLAY_MANUFACTURER_NAME_LEN));
              }
              echo tep_draw_pull_down_menu('refund_method', $refund_array, $default_refund['configuration_value'], 'id="refund_method" aria-describedby="refundMethod"');
			  ?>
		    </div>
		  </div>
	    </div>

	  <div class="clearfix"></div>
	  <?php
        $charge_query = tep_db_query("SELECT configuration_value FROM configuration where configuration_key = 'DEFAULT_RESTOCK_VALUE'");
        $charge = tep_db_fetch_array($charge_query);
			// Don't show re-stocking info if it's set to zero in Admin > Configuration > Stock
          if ($charge['configuration_value'] != 0) {
			echo '<div class="col-md-12"><div class="alert alert-danger" role="alert">' . sprintf(TEXT_RETURNS_SURCHARGE, $charge['configuration_value'] . '%') . '</div></div>';
          } 
	  ?>
	  
	  <div class="col-md-12">
		<div class="panel panel-success">
		  <div class="panel-heading">
			<h3 class="panel-title"><?php echo TEXT_RETURNS_TEXT; ?></h3>
		  </div>
		  <div class="panel-body">
			<?php echo tep_draw_textarea_field('returns_comments', 'soft', 60, 5, $comments, 'id="inputComments" placeholder="' . TEXT_RETURNS_COMMENTS . '"'); ?>
		  </div>
		</div>
	  </div>
	</div>			
  </div> <!-- end of contentText -->	  
    <div class="buttonSet row">
    <div class="col-xs-6"><?php echo tep_draw_button(IMAGE_BUTTON_BACK_TO_ORDER, 'fa fa-angle-left', tep_href_link('account_history_info.php', 'orders_id=' . $_GET['orders_id'], 'SSL')); ?></div>
    <div class="col-xs-6 text-right"><?php echo tep_draw_button(IMAGE_BUTTON_CONTINUE, 'fa fa-angle-right', null, 'primary', null, 'btn-success'); ?></div>
  </div>
  </form>
<?php
} else {
?>
  <div class="contentText">	  
	
	<h2><?php echo TEXT_RETURNS_SELECT_PRODUCT; ?></h2>


      <div class="panel-footer">
        <span class="pull-right"><?php echo HEADING_RETURNS_ORDER_DATE . ' ' . tep_date_long($order->info['date_purchased']); ?></span><strong><?php echo sprintf(HEADING_RETURNS_ORDER_NUMBER, $_GET['orders_id']); ?></strong>
      </div>      

	    <?php echo tep_draw_form('product_return', tep_href_link('return_product.php', 'action=return_new&orders_id=' . $_GET['orders_id'], 'SSL'), 'post', 'class="form-horizontal"', true); ?>

        <ul class="list-group">
		  <li class="list-group-item">
			<span class="pull-right"><strong><?php echo HEADING_RETURNS_ORIGINAL_QTY; ?></strong></span>
			<strong><?php echo HEADING_RETURNS_PRODUCTS; ?></strong>
		  </li>
		  <?php
		    for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
			  
			  $total_products_query = tep_db_query("select sum(products_quantity) as total FROM returned_products where products_id = '" . $order->products[$i]['id'] . "' and orders_id = '" . $_GET['orders_id'] . "'");
			  $total_products = tep_db_fetch_array($total_products_query);
				if ($total_products['total'] < $order->products[$i]['qty']) {
			  echo '		  <li class="list-group-item">' . "\n" .
				   '			<span class="pull-right">' . $order->products[$i]['qty'] . '</span>' . "\n" .
			       '            ' . tep_draw_radio_field('products_id', $order->products[$i]['id'], false, 'required aria-required="true"') . '&nbsp;&nbsp;' . $order->products[$i]['name'] . '&nbsp;&nbsp;' . "\n";

			  if ( (isset($order->products[$i]['attributes'])) && (sizeof($order->products[$i]['attributes']) > 0) ) {
			    for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {
				  echo '<br /><nobr><small>&nbsp;<i> - ' . $order->products[$i]['attributes'][$j]['option'] . ': ' . $order->products[$i]['attributes'][$j]['value'] . '</i></small></nobr>';
			    }
			  }

			  echo '		  </li>' . "\n";
			  } else {
				  echo '		  <li class="list-group-item text-muted">' . "\n" .
				   '			<span class="pull-right">' . $order->products[$i]['qty'] . '</span>' . "\n" .
			       '            ' . tep_draw_radio_field('products_id', $order->products[$i]['id'], false, 'disabled') . '&nbsp;&nbsp;' . $order->products[$i]['name'] . '<small>&nbsp;&nbsp;<em>' . TEXT_RETURNS_ALREADY_RETURNED . '</em></small>&nbsp;&nbsp;' . "\n";

			  if ( (isset($order->products[$i]['attributes'])) && (sizeof($order->products[$i]['attributes']) > 0) ) {
			    for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {
				  echo '<br /><nobr><small>&nbsp;<i> - ' . $order->products[$i]['attributes'][$j]['option'] . ': ' . $order->products[$i]['attributes'][$j]['value'] . '</i></small></nobr>';
			    }
			  }

			  echo '		  </li>' . "\n";
			  }

		    }
		  ?>
		</ul>
		  
		</ul>





  </div>

  <div class="clearfix"></div>

 <!-- end of contentText -->	
  <div class="buttonSet row">
    <div class="col-xs-6"><?php echo tep_draw_button(IMAGE_BUTTON_BACK_TO_ORDER, 'fa fa-angle-left', tep_href_link('account_history_info.php', 'order_id=' . $_GET['orders_id'], 'SSL')); ?></div>
    <div class="col-xs-6 text-right"><?php echo tep_draw_button(IMAGE_BUTTON_CONTINUE, 'fa fa-angle-right', null, 'primary', null, 'btn-success'); ?></div>
  </div>
</form>
<?php
}
?>
</div>


<?php
  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>
