<?php
/**
  * RMA Return System for osCommerce Online Merchant
  *
  * Author: frankl
  *
  * Portions @copyright (c) 2017 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */

  require('includes/application_top.php');
  include('includes/classes/returns.php');

  require('includes/languages/' . $language . '/returns_track.php');

  $breadcrumb->add(NAVBAR_TITLE, tep_href_link('returns_track.php'));
  
   if (!tep_session_is_registered('customer_id')) {
    $navigation->set_snapshot();
    tep_redirect(tep_href_link('login.php', '', 'SSL'));
  }

  if (!$_GET['action']){
      $_GET['action'] = 'returns_track';
  }
  if ($_GET['action']) {
    switch ($_GET['action']) {
    case 'returns_show':

       // first carry out a query on the database to see if there are any matching returns
       $database_returns_query = tep_db_query("SELECT returns_id, returns_status FROM returned_products where customers_id = '" . $customer_id . "' and rma_value = '" . $_POST['rma'] . "' or rma_value = '" . $_GET['rma'] . "'");
       if (!tep_db_num_rows($database_returns_query)) {
           $messageStack->add_session('returns_track', ERROR_RETURNS_NOT_EXIST, 'error');
           tep_redirect(tep_href_link('returns_track.php'));
       } else {
		  $returns_query = tep_db_fetch_array($database_returns_query);
		  $returns = new returns($returns_query['returns_id']);
		  
		  $refund_id_query = tep_db_query("select customer_method from refund_payments where returns_id = '" . $returns_query['returns_id'] . "'");
		  $refund_id = tep_db_fetch_array($refund_id_query);
		  
		  $refund_request_query = tep_db_query("select refund_method_name from refund_method where refund_method_id = '" . $refund_id['customer_method'] . "' and language_id = '" . (int)$languages_id . "'");
		  $refund_request = tep_db_fetch_array($refund_request_query);
       }

    break;
	
	case 'returns_track':

       // carry out a query on the database to see if there are any matching returns
       $database_returns_query = tep_db_query("SELECT returns_id, returns_status FROM returned_products where customers_id = '" . $customer_id . "'");
       if (!tep_db_num_rows($database_returns_query)) {
		   $messageStack->add_session('returns_track', ERROR_NO_RETURNS, 'error');
           tep_redirect(tep_href_link('returns_track.php', 'action=noreturns'));
       } else {
          $returns_query = tep_db_fetch_array($database_returns_query);
       }

    break;
	
		case 'noreturns':

       // carry out a query on the database to see if there are any matching returns
       $database_returns_query = tep_db_query("SELECT returns_id, rma_value FROM returned_products where customers_id = '" . $customer_id . "'");
       if (tep_db_num_rows($database_returns_query)) {
           tep_redirect(tep_href_link('returns_track.php', '', 'SSL'));
       } 

    break;

}
}

  require('includes/template_top.php');
?>

<div class="page-header">
  <h1><?php if ($_GET['action'] == 'returns_show') { echo HEADING_TITLE_RETURN; } else { echo HEADING_TITLE; } ; ?></h1>
</div>
<?php
  if ($messageStack->size('returns_track') > 0) {
    echo $messageStack->output('returns_track');
  }
?>
<div class="contentContainer">
    <?php
    if ($_GET['action'] == 'returns_track') {
	?>
  <div class="contentText">
    <div class="row">
	<?php
	 $database_returns_query = tep_db_query("SELECT returns_id, rma_value, orders_id, returns_status, return_reason_id, products_id, products_quantity, date_added FROM returned_products where customers_id = '" . $customer_id . "' order by date_added DESC");
	   while ($returns_query = tep_db_fetch_array($database_returns_query)) {
		$returned_products_query = tep_db_query("SELECT * FROM orders_products where products_id = '" . $returns_query['products_id'] . "' and orders_id = '" . $returns_query['orders_id'] . "'");
		$returned_products = tep_db_fetch_array($returned_products_query);
	 
		$returns_status_id = $returns_query['returns_status'];
		$returns_status_query = tep_db_query("SELECT returns_status_name FROM returns_status where returns_status_id = " . $returns_status_id . " and language_id = '" . (int)$languages_id . "'");
		$returns_status_array = tep_db_fetch_array($returns_status_query);
		$returns_status = $returns_status_array['returns_status_name'];
		$reason_query = tep_db_query("SELECT return_reason_name FROM return_reasons where return_reason_id = '" . $returns_query['return_reason_id'] . "' and language_id = '" . $languages_id . "'");
		$reason = tep_db_fetch_array($reason_query);
		$return_reason = $reason['return_reason_name'];
	?>
		<div class="panel panel-info">
		  <div class="panel-heading"><strong><?php echo sprintf(TEXT_RETURNS_YOUR_RMA_NUMBER, $returns_query['rma_value']) . ' <span class="badge pull-right">' . $returns_status . '</span>'; ?></strong></div>
		  <div class="panel-body">
			<div class="row">
			  <div class="col-sm-4"><?php echo '<strong>' . TEXT_RETURNS_DATE . '</strong> ' . tep_date_long($returns_query['date_added']) . '<br /><strong>' . TEXT_RETURNS_WHY_RETURN . '</strong> ' . $return_reason; ?></div>
			  <br class="visible-xs" />
			  <div class="col-sm-8"><?php echo '<strong>' . TEXT_RETURNS_PRODUCT . '</strong> ' . $returns_query['products_quantity'] . '&nbsp;x ' . $returned_products['products_name'] . '<br /><strong>' . TEXT_RETURNS_PRICE . '</strong> ' . $currencies->format(($returned_products['products_price'] + (tep_calculate_tax(($returned_products['products_price']),($returned_products['products_tax'])))) * ($returns_query['products_quantity'])); ?></div>
			</div>
		  </div>
		  <div class="panel-footer"><?php echo tep_draw_button(SMALL_IMAGE_BUTTON_VIEW, 'fa fa-file', tep_href_link('returns_track.php', 'action=returns_show&rma=' . $returns_query['rma_value']), 'primary', NULL, 'btn-primary btn-xs'); ?></div>
		</div>
<?php
	 }
	 ?>
	 </div>
  </div>
  <?php
	 
} elseif ($_GET['action'] == 'returns_show') { 

?>

  <div class="contentText">	
	  <div class="row">
		  <div class="col-md-12">
			<div class="panel panel-info">
			  <div class="panel-heading">
				<strong><?php echo sprintf(TEXT_RETURNS_YOUR_RMA_NUMBER, $returns->info['rma_value']) . ' <span class="badge pull-right">' . $returns->info['returns_status_name'] . '</span>'; ?></strong>
			  </div>
			  <div class="panel-body">
				<table class="table">
				  <tr>
					<th width="80"><?php echo HEADING_RETURNS_QUANTITY; ?></th>
					<th><?php echo HEADING_RETURNS_PRODUCTS; ?></th>
					<th><?php echo HEADING_RETURNS_TOTAL; ?></th>
				  </tr>
				  <tr>
					<td><?php echo $returns->products['qty']; ?></td>
					<td><?php echo $returns->products['name'];
							if (isset($returns->products['attributes']) && (sizeof($returns->products['attributes']) > 0)) {
							  for ($j = 0, $k = sizeof($returns->products['attributes']); $j < $k; $j++) {
							    echo '<br /><nobr><small>&nbsp;<i> - ' . $returns->products['attributes'][$j]['option'] . ': ' . $returns->products['attributes'][$j]['value'];
							    if ($returns->products['attributes'][$j]['price'] != '0') echo ' (' . $returns->products['attributes'][$j]['prefix'] . $currencies->format($returns->products['attributes'][$j]['price'] * $returns->products['qty'], true, $returns->info['currency'], $returns->info['currency_value']) . ')';
							    echo '</i></small></nobr>';
							  }
						    }  
						  ?></td>
					<td><?php echo $currencies->format(($returns->products['price'] + (tep_calculate_tax(($returns->products['price']),($returns->products['tax']))))) . TEXT_RETURNS_EACH; ?></td>
				  </tr>
				</table>
			  </div>
			</div>
		  </div>
	  <?php
	  if (RETURNS_SHOW_SERIAL_NUMBER == '1' && tep_not_null($returns->products['serial_number'])) {
	  ?>
	  <div class="col-md-12">
		<div class="panel panel-info">
		  <div class="panel-heading">
			<h3 class="panel-title"><?php echo TEXT_RETURNS_SERIAL_NUMBER; ?></h3>
		  </div>
		  <div class="panel-body">
			<?php echo $returns->products['serial_number']; ?>
		  </div>
		</div>
	  </div>
	  <?php
	  }
	  ?>
	  </div>
	  <?php
	  if ($returns->info['finalised'] == 1) {
	  ?>
	    <div class="row">
		  <div class="col-md-4">
			<div class="panel panel-success">
			  <div class="panel-heading">
				<h3 class="panel-title"><?php echo TEXT_RETURNS_CONTACT_USER_EMAIL; ?></h3>
			  </div>
			  <div class="panel-body">
				<?php echo $returns->customer['email_address']; ?>
			  </div>
			</div>
		  </div>
		  
		  <div class="col-md-4">
			<div class="panel panel-success">
			  <div class="panel-heading">
				<h3 class="panel-title"><?php echo TEXT_RETURNS_FINAL_RETURN_REASON; ?></h3>
			  </div>
			  <div class="panel-body">
				<?php echo $returns->info['return_reason_name'];
				?>
			  </div>
			</div>
		  </div>
		  
		  <div class="col-md-4">
			<div class="panel panel-success">
			  <div class="panel-heading">
				<h3 class="panel-title"><?php echo TEXT_RETURNS_RESOLUTION; ?></h3>
			  </div>
			  <div class="panel-body">
				<?php echo $returns->info['refund_payment_name']; ?>
			  </div>
			</div>
		  </div>
	  </div>
	  <?php
	  } else {
	  ?>
	  <div class="row">
		  <div class="col-md-4">
			<div class="panel panel-warning">
			  <div class="panel-heading">
				<h3 class="panel-title"><?php echo TEXT_RETURNS_CONTACT_USER_EMAIL; ?></h3>
			  </div>
			  <div class="panel-body">
				<?php echo $returns->customer['email_address']; ?>
			  </div>
			</div>
		  </div>
		  
		  <div class="col-md-4">
			<div class="panel panel-info">
			  <div class="panel-heading">
				<h3 class="panel-title"><?php echo TEXT_RETURNS_WHY_RETURN; ?></h3>
			  </div>
			  <div class="panel-body">
				<?php echo $returns->info['return_reason_name'];
				?>
			  </div>
			</div>
		  </div>
		  
		  <div class="col-md-4">
			<div class="panel panel-warning">
			  <div class="panel-heading">
				<h3 class="panel-title"><?php echo TEXT_RETURNS_PREF_REFUND_METHOD; ?></h3>
			  </div>
			  <div class="panel-body">
				<?php echo $refund_request['refund_method_name']; ?>
			  </div>
			</div>
		  </div>
	  </div>
	  <?php
	  } 
	  ?> 
  <div class="clearfix"></div>
  <div class="contentText">
    <ul class="timeline">
      <?php
      $statuses_query = tep_db_query("select rs.returns_status_name, rsh.date_added, rsh.comments from returns_status rs, returns_status_history rsh where rsh.returns_id = '" . (int)$returns_query['returns_id'] . "' and rsh.returns_status_id = rs.returns_status_id and rs.language_id = '" . (int)$languages_id . "' and rs.public_flag = '1' order by rsh.date_added DESC");
      while ($statuses = tep_db_fetch_array($statuses_query)) {
        echo '<li>';
        echo '  <div class="timeline-badge"><i class="fa fa-check-square-o"></i></div>';
        echo '  <div class="timeline-panel">';
        echo '    <div class="timeline-heading">';
        echo '      <p class="pull-right"><small class="text-muted"><i class="fa fa-clock-o"></i> ' . tep_date_short($statuses['date_added']) . '</small></p><h2 class="timeline-title">' . $statuses['returns_status_name'] . '</h2>';
        echo '    </div>';
        echo '    <div class="timeline-body">';
        echo '      <p>' . (empty($statuses['comments']) ? '&nbsp;' : '<blockquote>' . nl2br(tep_output_string_protected($statuses['comments'])) . '</blockquote>') . '</p>';
        echo '    </div>';
        echo '  </div>';
        echo '</li>';
      }
      ?>
    </ul>
  </div>
 </div> 
<?php
}

?>

  <div class="buttonSet">
    <div class="text-right"><?php echo tep_draw_button(IMAGE_BUTTON_CONTINUE, 'fa fa-angle-right', tep_href_link('index.php')); ?></div>
  </div>
</div>
<?php
  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>
